"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// tslint:disable
/**
 * An object that keeps track of all possible error messages.
 */
exports.diagnosticMessages = {
    //this one won't be used much, we just need a catchall object for the code since we pass through the message from the parser
    Generic_parser_message: function () { return ({
        message: "There was an error parsing the file",
        code: 1000,
    }); },
    Call_to_unknown_function_1001: function (name, scopeName) { return ({
        message: "Cannot find function with name '" + name + "' when this file is included in scope \"" + scopeName + "\".",
        code: 1001
    }); },
    Expected_a_arguments_but_got_b_1002: function (expectedCount, actualCount) { return ({
        message: "Expected " + expectedCount + " arguments, but got " + actualCount + ".",
        code: 1002
    }); },
    Duplicate_function_implementation_1003: function (functionName, scopeName) { return ({
        message: "Duplicate function implementation for \"" + functionName + "\" when this file is included in scope \"" + scopeName + "\".",
        code: 1003
    }); },
    Referenced_file_does_not_exist_1004: function () { return ({
        message: "Referenced file does not exist.",
        code: 1004
    }); },
    Xml_component_missing_component_declaration_1005: function () { return ({
        message: "Missing a component declaration.",
        code: 1005
    }); },
    Component_missing_name_attribute_1006: function () { return ({
        message: "Component must have a name attribute.",
        code: 1006
    }); },
    Component_missing_extends_attribute_1007: function () { return ({
        message: "Component must have an extends attribute.",
        code: 1007
    }); },
    Xml_parse_error_1008: function () { return ({
        //generic catchall xml parse error
        message: "Invalid xml",
        code: 1008
    }); },
    Unnecessary_script_import_in_child_from_parent_1009: function (parentComponentName) { return ({
        message: "Unnecessary script import: Script is already imported in ancestor component \"" + parentComponentName + "\".",
        code: 1009
    }); },
    Shadows_ancestor_function_1010: function (callableName, currentContextName, parentFilePath, parentContextName) { return ({
        message: "Function \"" + callableName + "\" included in \"" + currentContextName + "\" shadows function in \"" + parentFilePath + "\" included in \"" + parentContextName + "\".",
        code: 1010
    }); },
    Local_var_shadows_global_function_1011: function (localName, globalLocation) { return ({
        message: "Local var \"" + localName + "\" has same name as global function in \"" + globalLocation + "\" and will never be called.",
        code: 1011
    }); },
    Script_import_case_mismatch_1012: function (correctFilePath) { return ({
        message: "Script import path does not match casing of actual file path \"" + correctFilePath + "\".",
        code: 1012
    }); },
    File_not_referenced_by_any_file_1013: function () { return ({
        message: "This file is not referenced by any other file in the project.",
        code: 1013
    }); },
    Unknown_diagnostic_code_1014: function (theUnknownCode) { return ({
        message: "Unknown diagnostic code " + theUnknownCode,
        code: 1014
    }); },
    Script_src_cannot_be_empty_1015: function () { return ({
        message: "Script import cannot be empty or whitespace",
        code: 1015
    }); }
};
var allCodes = [];
for (var key in exports.diagnosticMessages) {
    allCodes.push(exports.diagnosticMessages[key]().code);
}
exports.diagnosticCodes = allCodes;
//# sourceMappingURL=DiagnosticMessages.js.map