import * as brs from 'brs';
import { Range } from 'vscode-languageserver';
import { VariableDeclaration } from './interfaces';
export declare class FunctionScope {
    func: brs.parser.Expr.Function;
    constructor(func: brs.parser.Expr.Function);
    /**
     * The range that the body of this scope covers
     */
    bodyRange: Range;
    /**
     * The full range of this function. Starts at the position of the `f` in function or `s` in sub,
     * and ends after the final `n` in `end function` or `b` in end sub.
     */
    range: Range;
    /**
     * The scopes that are children of this scope
     */
    childrenScopes: FunctionScope[];
    /**
     * The parent scope of this scope
     */
    parentScope: FunctionScope;
    variableDeclarations: VariableDeclaration[];
    /**
     * Find all variable declarations above the given line index
     * @param lineIndex
     */
    getVariablesAbove(lineIndex: number): VariableDeclaration[];
    getVariableByName(name: string): VariableDeclaration;
}
