"use strict";
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var FunctionScope = /** @class */ (function () {
    function FunctionScope(func) {
        this.func = func;
        /**
         * The scopes that are children of this scope
         */
        this.childrenScopes = [];
        this.variableDeclarations = [];
    }
    /**
     * Find all variable declarations above the given line index
     * @param lineIndex
     */
    FunctionScope.prototype.getVariablesAbove = function (lineIndex) {
        var e_1, _a;
        var results = [];
        try {
            for (var _b = __values(this.variableDeclarations), _c = _b.next(); !_c.done; _c = _b.next()) {
                var variableDeclaration = _c.value;
                if (variableDeclaration.lineIndex < lineIndex) {
                    results.push(variableDeclaration);
                }
                else {
                    break;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return results;
    };
    FunctionScope.prototype.getVariableByName = function (name) {
        var e_2, _a;
        name = name.toLowerCase();
        try {
            for (var _b = __values(this.variableDeclarations), _c = _b.next(); !_c.done; _c = _b.next()) {
                var variableDeclaration = _c.value;
                if (variableDeclaration.name.toLowerCase() === name) {
                    return variableDeclaration;
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_2) throw e_2.error; }
        }
    };
    return FunctionScope;
}());
exports.FunctionScope = FunctionScope;
//# sourceMappingURL=FunctionScope.js.map