"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var vscode_languageserver_1 = require("vscode-languageserver");
var vscode_uri_1 = require("vscode-uri");
var ProgramBuilder_1 = require("./ProgramBuilder");
var util_1 = require("./util");
var LanguageServer = /** @class */ (function () {
    function LanguageServer() {
        this.workspaces = [];
        this.hasConfigurationCapability = false;
        /**
         * Indicates whether the client supports workspace folders
         */
        this.clientHasWorkspaceFolderCapability = false;
        /**
         * Create a simple text document manager.
         * The text document manager supports full document sync only
         */
        this.documents = new vscode_languageserver_1.TextDocuments();
        /**
         * The list of all issues, indexed by file. This allows us to keep track of which buckets of
         * diagnostics to send and which to skip because nothing has changed
         */
        this.latestDiagnosticsByFile = {};
    }
    LanguageServer.prototype.createConnection = function () {
        return vscode_languageserver_1.createConnection(vscode_languageserver_1.ProposedFeatures.all);
    };
    //run the server
    LanguageServer.prototype.run = function () {
        var _this = this;
        // Create a connection for the server. The connection uses Node's IPC as a transport.
        // Also include all preview / proposed LSP features.
        this.connection = this.createConnection();
        this.connection.onInitialize(this.onInitialize.bind(this));
        this.connection.onInitialized(this.onInitialized.bind(this));
        this.connection.onDidChangeConfiguration(this.onDidChangeConfiguration.bind(this));
        this.connection.onDidChangeWatchedFiles(this.onDidChangeWatchedFiles.bind(this));
        // The content of a text document has changed. This event is emitted
        // when the text document is first opened, when its content has changed,
        // or when document is closed without saving (original contents are sent as a change)
        //
        this.documents.onDidChangeContent(function (change) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.validateTextDocument(change.document)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        // This handler provides the initial list of the completion items.
        this.connection.onCompletion(this.onCompletion.bind(this));
        // This handler resolves additional information for the item selected in
        // the completion list.
        this.connection.onCompletionResolve(this.onCompletionResolve.bind(this));
        this.connection.onDefinition(this.onDefinition.bind(this));
        this.connection.onHover(this.onHover.bind(this));
        /*
        this.connection.onDidOpenTextDocument((params) => {
             // A text document got opened in VSCode.
             // params.uri uniquely identifies the document. For documents store on disk this is a file URI.
             // params.text the initial full content of the document.
            this.connection.console.log(`${params.textDocument.uri} opened.`);
        });
        this.connection.onDidChangeTextDocument((params) => {
             // The content of a text document did change in VSCode.
             // params.uri uniquely identifies the document.
             // params.contentChanges describe the content changes to the document.
            this.connection.console.log(`${params.textDocument.uri} changed: ${JSON.stringify(params.contentChanges)}`);
        });
        this.connection.onDidCloseTextDocument((params) => {
             // A text document got closed in VSCode.
             // params.uri uniquely identifies the document.
            this.connection.console.log(`${params.textDocument.uri} closed.`);
        });
        */
        // listen for open, change and close text document events
        this.documents.listen(this.connection);
        // Listen on the connection
        this.connection.listen();
    };
    /**
     * Called when the client starts initialization
     * @param params
     */
    LanguageServer.prototype.onInitialize = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var clientCapabilities;
            return __generator(this, function (_a) {
                clientCapabilities = params.capabilities;
                // Does the client support the `workspace/configuration` request?
                // If not, we will fall back using global settings
                this.hasConfigurationCapability = !!(clientCapabilities.workspace && !!clientCapabilities.workspace.configuration);
                this.clientHasWorkspaceFolderCapability = !!(clientCapabilities.workspace && !!clientCapabilities.workspace.workspaceFolders);
                //return the capabilities of the server
                return [2 /*return*/, {
                        capabilities: {
                            textDocumentSync: this.documents.syncKind,
                            // Tell the client that the server supports code completion
                            completionProvider: {
                                resolveProvider: true
                            },
                            definitionProvider: true,
                            hoverProvider: true
                        }
                    }];
            });
        });
    };
    /**
     * Called when the client has finished initializing
     * @param params
     */
    LanguageServer.prototype.onInitialized = function () {
        return __awaiter(this, void 0, void 0, function () {
            var workspaceFolders, workspacePaths;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.hasConfigurationCapability) return [3 /*break*/, 2];
                        // Register for all configuration changes.
                        return [4 /*yield*/, this.connection.client.register(vscode_languageserver_1.DidChangeConfigurationNotification.type, undefined)];
                    case 1:
                        // Register for all configuration changes.
                        _a.sent();
                        _a.label = 2;
                    case 2: return [4 /*yield*/, this.connection.workspace.getWorkspaceFolders()];
                    case 3:
                        workspaceFolders = _a.sent();
                        workspacePaths = workspaceFolders.map(function (x) {
                            return util_1.default.uriToPath(x.uri);
                        });
                        return [4 /*yield*/, this.createWorkspaces(workspacePaths)];
                    case 4:
                        _a.sent();
                        if (this.clientHasWorkspaceFolderCapability) {
                            this.connection.workspace.onDidChangeWorkspaceFolders(function (evt) { return __awaiter(_this, void 0, void 0, function () {
                                var e_1, _a, _loop_1, this_1, _b, _c, removed;
                                return __generator(this, function (_d) {
                                    switch (_d.label) {
                                        case 0:
                                            _loop_1 = function (removed) {
                                                var workspacePath = util_1.default.uriToPath(removed.uri);
                                                var workspace = this_1.workspaces.find(function (x) { return x.workspacePath === workspacePath; });
                                                if (workspace) {
                                                    workspace.builder.dispose();
                                                    this_1.workspaces.splice(this_1.workspaces.indexOf(workspace), 1);
                                                }
                                            };
                                            this_1 = this;
                                            try {
                                                //remove programs for removed workspace folders
                                                for (_b = __values(evt.removed), _c = _b.next(); !_c.done; _c = _b.next()) {
                                                    removed = _c.value;
                                                    _loop_1(removed);
                                                }
                                            }
                                            catch (e_1_1) { e_1 = { error: e_1_1 }; }
                                            finally {
                                                try {
                                                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                                                }
                                                finally { if (e_1) throw e_1.error; }
                                            }
                                            //create programs for new workspace folders
                                            return [4 /*yield*/, this.createWorkspaces(evt.added.map(function (x) { return util_1.default.uriToPath(x.uri); }))];
                                        case 1:
                                            //create programs for new workspace folders
                                            _d.sent();
                                            return [2 /*return*/];
                                    }
                                });
                            }); });
                        }
                        return [4 /*yield*/, this.waitAllProgramFirstRuns()];
                    case 5:
                        _a.sent();
                        this.sendDiagnostics();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Send a critical failure notification to the client, which should show a notification of some kind
     */
    LanguageServer.prototype.sendCriticalFailure = function (message) {
        this.connection.sendNotification('critical-failure', message);
    };
    /**
     * Wait for all programs' first run to complete
     */
    LanguageServer.prototype.waitAllProgramFirstRuns = function () {
        return __awaiter(this, void 0, void 0, function () {
            var e_2, _a, status, _b, _c, workspace, e_3, e_2_1;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _d.trys.push([0, 7, 8, 9]);
                        _b = __values(this.workspaces), _c = _b.next();
                        _d.label = 1;
                    case 1:
                        if (!!_c.done) return [3 /*break*/, 6];
                        workspace = _c.value;
                        _d.label = 2;
                    case 2:
                        _d.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, workspace.firstRunPromise];
                    case 3:
                        _d.sent();
                        return [3 /*break*/, 5];
                    case 4:
                        e_3 = _d.sent();
                        status = 'critical-error';
                        //the first run failed...that won't change unless we reload the workspace, so replace with resolved promise
                        //so we don't show this error again
                        workspace.firstRunPromise = Promise.resolve();
                        this.sendCriticalFailure("BrightScript language server failed to start: \n" + e_3.message);
                        return [3 /*break*/, 5];
                    case 5:
                        _c = _b.next();
                        return [3 /*break*/, 1];
                    case 6: return [3 /*break*/, 9];
                    case 7:
                        e_2_1 = _d.sent();
                        e_2 = { error: e_2_1 };
                        return [3 /*break*/, 9];
                    case 8:
                        try {
                            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                        }
                        finally { if (e_2) throw e_2.error; }
                        return [7 /*endfinally*/];
                    case 9:
                        this.connection.sendNotification('build-status', status ? status : 'success');
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Create project for each new workspace. If the workspace is already known,
     * it is skipped.
     * @param workspaceFolders
     */
    LanguageServer.prototype.createWorkspaces = function (workspacePaths) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Promise.all(workspacePaths.map(function (workspacePath) { return _this.createWorkspace(workspacePath); }))];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    /**
     * Event handler for when the program wants to load file contents.
     * anytime the program wants to load a file, check with our in-memory document cache first
     */
    LanguageServer.prototype.documentFileResolver = function (pathAbsolute) {
        var pathUri = vscode_uri_1.default.file(pathAbsolute).toString();
        var document = this.documents.get(pathUri);
        if (document) {
            return document.getText();
        }
    };
    LanguageServer.prototype.createWorkspace = function (workspacePath) {
        return __awaiter(this, void 0, void 0, function () {
            var workspace, builder, config, cwd, configFilePath, firstRunPromise, newWorkspace;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        workspace = this.workspaces.find(function (x) { return x.workspacePath === workspacePath; });
                        //skip this workspace if we already have it
                        if (workspace) {
                            return [2 /*return*/];
                        }
                        builder = new ProgramBuilder_1.ProgramBuilder();
                        //prevent clearing the console on run...this isn't the CLI so we want to keep a full log of everything
                        builder.allowConsoleClearing = false;
                        //look for files in our in-memory cache before going to the file system
                        builder.addFileResolver(function (pathAbsolute) {
                            return _this.documentFileResolver(pathAbsolute);
                        });
                        return [4 /*yield*/, this.connection.workspace.getConfiguration({
                                scopeUri: vscode_uri_1.default.parse(workspacePath).toString(),
                                section: 'brightscript'
                            })];
                    case 1:
                        config = _a.sent();
                        cwd = workspacePath;
                        configFilePath = config.configFile ? path.resolve(workspacePath, config.configFile) : 'brsconfig.json';
                        return [4 /*yield*/, util_1.default.fileExists(configFilePath)];
                    case 2:
                        //if the config file exists, use it and its folder as cwd
                        if (_a.sent()) {
                            cwd = path.dirname(configFilePath);
                        }
                        else {
                            //config file doesn't exist...let `brightscript-language` resolve the default way
                            configFilePath = undefined;
                        }
                        firstRunPromise = builder.run({
                            cwd: cwd,
                            project: configFilePath,
                            watch: false,
                            skipPackage: true,
                            deploy: false
                        }).catch(function (err) {
                            console.error(err);
                        });
                        newWorkspace = {
                            builder: builder,
                            firstRunPromise: firstRunPromise,
                            workspacePath: workspacePath,
                            isFirstRunComplete: false,
                            isFirstRunSuccessful: false,
                            configFilePath: configFilePath
                        };
                        this.workspaces.push(newWorkspace);
                        firstRunPromise.then(function () {
                            newWorkspace.isFirstRunComplete = true;
                            newWorkspace.isFirstRunSuccessful = true;
                        }).catch(function () {
                            newWorkspace.isFirstRunComplete = true;
                            newWorkspace.isFirstRunSuccessful = false;
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Provide a list of completion items based on the current cursor position
     * @param textDocumentPosition
     */
    LanguageServer.prototype.onCompletion = function (textDocumentPosition) {
        return __awaiter(this, void 0, void 0, function () {
            var e_4, _a, filePath, completions, result, completions_1, completions_1_1, completion;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: 
                    //ensure programs are initialized
                    return [4 /*yield*/, this.waitAllProgramFirstRuns()];
                    case 1:
                        //ensure programs are initialized
                        _b.sent();
                        filePath = util_1.default.uriToPath(textDocumentPosition.textDocument.uri);
                        completions = Array.prototype.concat.apply([], this.workspaces.map(function (x) {
                            if (x.builder.program.hasFile(filePath)) {
                                return x.builder.program.getCompletions(filePath, textDocumentPosition.position);
                            }
                        }));
                        result = [];
                        try {
                            for (completions_1 = __values(completions), completions_1_1 = completions_1.next(); !completions_1_1.done; completions_1_1 = completions_1.next()) {
                                completion = completions_1_1.value;
                                result.push(completion);
                            }
                        }
                        catch (e_4_1) { e_4 = { error: e_4_1 }; }
                        finally {
                            try {
                                if (completions_1_1 && !completions_1_1.done && (_a = completions_1.return)) _a.call(completions_1);
                            }
                            finally { if (e_4) throw e_4.error; }
                        }
                        return [2 /*return*/, result];
                }
            });
        });
    };
    /**
     * Provide a full completion item from the selection
     * @param item
     */
    LanguageServer.prototype.onCompletionResolve = function (item) {
        if (item.data === 1) {
            (item.detail = 'TypeScript details'),
                (item.documentation = 'TypeScript documentation');
        }
        else if (item.data === 2) {
            (item.detail = 'JavaScript details'),
                (item.documentation = 'JavaScript documentation');
        }
        return item;
    };
    /**
     * Reload all specified workspaces, or all workspaces if no workspaces are specified
     */
    LanguageServer.prototype.reloadWorkspaces = function (workspaces) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        workspaces = workspaces ? workspaces : __spread(this.workspaces);
                        return [4 /*yield*/, Promise.all(workspaces.map(function (workspace) { return __awaiter(_this, void 0, void 0, function () {
                                var e_5, idx;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            _a.trys.push([0, 2, , 3]);
                                            return [4 /*yield*/, workspace.firstRunPromise];
                                        case 1:
                                            _a.sent();
                                            return [3 /*break*/, 3];
                                        case 2:
                                            e_5 = _a.sent();
                                            return [3 /*break*/, 3];
                                        case 3:
                                            idx = this.workspaces.indexOf(workspace);
                                            if (idx > -1) {
                                                //remove this workspace
                                                this.workspaces.splice(idx, 1);
                                                //dispose this workspace's resources
                                                workspace.builder.dispose();
                                            }
                                            //create a new workspace/brs program
                                            return [4 /*yield*/, this.createWorkspace(workspace.workspacePath)];
                                        case 4:
                                            //create a new workspace/brs program
                                            _a.sent();
                                            return [2 /*return*/];
                                    }
                                });
                            }); }))];
                    case 1:
                        _a.sent();
                        //wait for all of the programs to finish starting up
                        return [4 /*yield*/, this.waitAllProgramFirstRuns()];
                    case 2:
                        //wait for all of the programs to finish starting up
                        _a.sent();
                        //validate each workspace
                        return [4 /*yield*/, Promise.all(this.workspaces.map(function (x) {
                                //only validate workspaces with a working builder (i.e. no critical runtime errors)
                                if (x.isFirstRunComplete && x.isFirstRunSuccessful) {
                                    return x.builder.program.validate();
                                }
                            }))];
                    case 3:
                        //validate each workspace
                        _a.sent();
                        //send all diagnostics
                        this.sendDiagnostics();
                        return [2 /*return*/];
                }
            });
        });
    };
    LanguageServer.prototype.onDidChangeConfiguration = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.hasConfigurationCapability) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.reloadWorkspaces()];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 2];
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Called when watched files changed (add/change/delete).
     * The client is in charge of what files to watch, so all client
     * implementations should ensure that all valid brightscript project
     * file types are watched (.brs,.bs,.xml,manifest, and any json/text/image files)
     * @param params
     */
    LanguageServer.prototype.onDidChangeWatchedFiles = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var e_6, _a, workspacesToReload, filePaths, _b, _c, workspace;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0: 
                    //ensure programs are initialized
                    return [4 /*yield*/, this.waitAllProgramFirstRuns()];
                    case 1:
                        //ensure programs are initialized
                        _d.sent();
                        this.connection.sendNotification('build-status', 'building');
                        workspacesToReload = [];
                        filePaths = params.changes.map(function (x) { return util_1.default.uriToPath(x.uri); });
                        try {
                            for (_b = __values(this.workspaces), _c = _b.next(); !_c.done; _c = _b.next()) {
                                workspace = _c.value;
                                if (filePaths.indexOf(workspace.configFilePath) > -1) {
                                    workspacesToReload.push(workspace);
                                }
                            }
                        }
                        catch (e_6_1) { e_6 = { error: e_6_1 }; }
                        finally {
                            try {
                                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                            }
                            finally { if (e_6) throw e_6.error; }
                        }
                        return [4 /*yield*/, this.reloadWorkspaces(workspacesToReload)];
                    case 2:
                        _d.sent();
                        return [4 /*yield*/, Promise.all(this.workspaces.map(function (x) { return x.builder.handleFileChanges(params.changes); }))];
                    case 3:
                        _d.sent();
                        //revalidate the program
                        return [4 /*yield*/, Promise.all(this.workspaces.map(function (x) { return x.builder.program.validate(); }))];
                    case 4:
                        //revalidate the program
                        _d.sent();
                        //send all diagnostics to the client
                        this.sendDiagnostics();
                        this.connection.sendNotification('build-status', 'success');
                        return [2 /*return*/];
                }
            });
        });
    };
    LanguageServer.prototype.onHover = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var pathAbsolute, hovers, hover;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    //ensure programs are initialized
                    return [4 /*yield*/, this.waitAllProgramFirstRuns()];
                    case 1:
                        //ensure programs are initialized
                        _a.sent();
                        pathAbsolute = util_1.default.uriToPath(params.textDocument.uri);
                        hovers = Array.prototype.concat.call([], this.workspaces.map(function (x) { return x.builder.program.getHover(pathAbsolute, params.position); }));
                        hover = hovers.filter(function (x) { return !!x; })[0];
                        //TODO improve this to support more than just .brs files
                        if (hover && hover.contents) {
                            //create fenced code block to get colorization
                            hover.contents = {
                                language: 'brightscript',
                                value: hover.contents
                            };
                        }
                        return [2 /*return*/, hover];
                }
            });
        });
    };
    LanguageServer.prototype.validateTextDocument = function (textDocument) {
        return __awaiter(this, void 0, void 0, function () {
            var filePath, documentText, e_7;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.connection.sendNotification('build-status', 'building');
                        //ensure programs are initialized
                        return [4 /*yield*/, this.waitAllProgramFirstRuns()];
                    case 1:
                        //ensure programs are initialized
                        _a.sent();
                        filePath = vscode_uri_1.default.parse(textDocument.uri).fsPath;
                        documentText = textDocument.getText();
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 5, , 6]);
                        return [4 /*yield*/, Promise.all(this.workspaces.map(function (x) {
                                //only add or replace existing files. All of the files in the project should
                                //have already been loaded by other means
                                if (x.builder.program.hasFile(filePath)) {
                                    return x.builder.program.addOrReplaceFile(filePath, documentText);
                                }
                            }))];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, Promise.all(this.workspaces.map(function (x) { return x.builder.program.validate(); }))];
                    case 4:
                        _a.sent();
                        return [3 /*break*/, 6];
                    case 5:
                        e_7 = _a.sent();
                        this.sendCriticalFailure("Critical error parsing/validating " + filePath + ": " + e_7.message);
                        return [3 /*break*/, 6];
                    case 6:
                        this.sendDiagnostics();
                        this.connection.sendNotification('build-status', 'success');
                        return [2 /*return*/];
                }
            });
        });
    };
    LanguageServer.prototype.onDefinition = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var e_8, _a, results, pathAbsolute, _b, _c, workspace;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0: 
                    //WARNING: This only works for a few small xml cases because the vscode-brightscript-language extension
                    //already implemented this feature, and I haven't had time to port all of that functionality over to
                    //this codebase
                    //TODO implement for brightscript also
                    return [4 /*yield*/, this.waitAllProgramFirstRuns()];
                    case 1:
                        //WARNING: This only works for a few small xml cases because the vscode-brightscript-language extension
                        //already implemented this feature, and I haven't had time to port all of that functionality over to
                        //this codebase
                        //TODO implement for brightscript also
                        _d.sent();
                        results = [];
                        pathAbsolute = util_1.default.uriToPath(params.textDocument.uri);
                        try {
                            for (_b = __values(this.workspaces), _c = _b.next(); !_c.done; _c = _b.next()) {
                                workspace = _c.value;
                                results = results.concat.apply(results, __spread(workspace.builder.program.getDefinition(pathAbsolute, params.position)));
                            }
                        }
                        catch (e_8_1) { e_8 = { error: e_8_1 }; }
                        finally {
                            try {
                                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                            }
                            finally { if (e_8) throw e_8.error; }
                        }
                        return [2 /*return*/, results];
                }
            });
        });
    };
    LanguageServer.prototype.sendDiagnostics = function () {
        var e_9, _a, e_10, _b;
        //compute the new list of diagnostics for whole project
        var issuesByFile = {};
        try {
            // let uri = Uri.parse(textDocument.uri);
            //make a bucket for every file in every project
            for (var _c = __values(this.workspaces), _d = _c.next(); !_d.done; _d = _c.next()) {
                var workspace = _d.value;
                for (var filePath in workspace.builder.program.files) {
                    issuesByFile[filePath] = [];
                }
            }
        }
        catch (e_9_1) { e_9 = { error: e_9_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_9) throw e_9.error; }
        }
        var diagnostics = Array.prototype.concat.apply([], this.workspaces.map(function (x) { return x.builder.program.getDiagnostics(); }));
        try {
            for (var diagnostics_1 = __values(diagnostics), diagnostics_1_1 = diagnostics_1.next(); !diagnostics_1_1.done; diagnostics_1_1 = diagnostics_1.next()) {
                var diagnostic = diagnostics_1_1.value;
                issuesByFile[diagnostic.file.pathAbsolute].push({
                    severity: util_1.default.severityToDiagnostic(diagnostic.severity),
                    range: diagnostic.location,
                    message: diagnostic.message,
                    code: diagnostic.code,
                    source: 'brs'
                });
            }
        }
        catch (e_10_1) { e_10 = { error: e_10_1 }; }
        finally {
            try {
                if (diagnostics_1_1 && !diagnostics_1_1.done && (_b = diagnostics_1.return)) _b.call(diagnostics_1);
            }
            finally { if (e_10) throw e_10.error; }
        }
        //send all diagnostics
        for (var filePath in issuesByFile) {
            //TODO filter by only the files that have changed
            this.connection.sendDiagnostics({
                uri: vscode_uri_1.default.file(filePath).toString(),
                diagnostics: issuesByFile[filePath]
            });
        }
        //clear any diagnostics for files that are no longer present
        var currentFilePaths = Object.keys(issuesByFile);
        for (var filePath in this.latestDiagnosticsByFile) {
            if (currentFilePaths.indexOf(filePath) === -1) {
                this.connection.sendDiagnostics({
                    uri: vscode_uri_1.default.file(filePath).toString(),
                    diagnostics: []
                });
            }
        }
        //save the new list of diagnostics
        this.latestDiagnosticsByFile = issuesByFile;
    };
    return LanguageServer;
}());
exports.LanguageServer = LanguageServer;
//# sourceMappingURL=LanguageServer.js.map