"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var events_1 = require("events");
var path = require("path");
var vscode_languageserver_1 = require("vscode-languageserver");
var Context_1 = require("./Context");
var DiagnosticMessages_1 = require("./DiagnosticMessages");
var BrsFile_1 = require("./files/BrsFile");
var XmlFile_1 = require("./files/XmlFile");
var platformCallables_1 = require("./platformCallables");
var util_1 = require("./util");
var XmlContext_1 = require("./XmlContext");
var Program = /** @class */ (function () {
    function Program(
    /**
     * The root directory for this program
     */
    options) {
        this.options = options;
        /**
         * A list of functions that will be used to load file contents.
         * In most cases, there will only be the "read from filesystem" resolver.
         * However, when running inside the LanguageServer, a second resolver will be added
         * to resolve the opened file contents from memory instead of going to disk.
         */
        this.fileResolvers = [];
        /**
         * A set of diagnostics. This does not include any of the context diagnostics.
         * Should only be set from `this.validate()`
         */
        this.diagnostics = [];
        /**
         * A map of every file loaded into this program
         */
        this.files = {};
        this.contexts = {};
        this.emitter = new events_1.EventEmitter();
        //allow unlimited listeners
        this.emitter.setMaxListeners(0);
        this.options = util_1.default.normalizeConfig(options);
        //normalize the root dir path
        this.rootDir = util_1.default.getRootDir(options);
        //create the 'platform' context
        this.platformContext = new Context_1.Context('platform', function (file) { return false; });
        //add all platform callables
        this.platformContext.addOrReplaceFile(platformCallables_1.platformFile);
        platformCallables_1.platformFile.program = this;
        this.platformContext.attachProgram(this);
        //for now, disable validation of this context because the platform files have some duplicate method declarations
        this.platformContext.validate = function () { return []; };
        this.platformContext.isValidated = true;
        //create the "global" context
        var globalContext = new Context_1.Context('global', function (file) {
            //global context includes every file under the `source` folder
            return file.pkgPath.indexOf("source" + path.sep) === 0;
        });
        globalContext.attachProgram(this);
        //the global context inherits from platform context
        globalContext.attachParentContext(this.platformContext);
        this.contexts[globalContext.name] = globalContext;
        //add the default file resolver
        this.fileResolvers.push(function (pathAbsolute) {
            return util_1.default.getFileContents(pathAbsolute);
        });
    }
    /**
     * Get the contents of the specified file as a string.
     * This walks backwards through the file resolvers until we get a value.
     * This allow the language server to provide file contents directly from memory.
     */
    Program.prototype.getFileContents = function (pathAbsolute) {
        return __awaiter(this, void 0, void 0, function () {
            var e_1, _a, reversedResolvers, reversedResolvers_1, reversedResolvers_1_1, fileResolver, result, e_1_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        reversedResolvers = __spread(this.fileResolvers).reverse();
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 6, 7, 8]);
                        reversedResolvers_1 = __values(reversedResolvers), reversedResolvers_1_1 = reversedResolvers_1.next();
                        _b.label = 2;
                    case 2:
                        if (!!reversedResolvers_1_1.done) return [3 /*break*/, 5];
                        fileResolver = reversedResolvers_1_1.value;
                        return [4 /*yield*/, fileResolver(pathAbsolute)];
                    case 3:
                        result = _b.sent();
                        if (typeof result === 'string') {
                            return [2 /*return*/, result];
                        }
                        _b.label = 4;
                    case 4:
                        reversedResolvers_1_1 = reversedResolvers_1.next();
                        return [3 /*break*/, 2];
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        e_1_1 = _b.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 8];
                    case 7:
                        try {
                            if (reversedResolvers_1_1 && !reversedResolvers_1_1.done && (_a = reversedResolvers_1.return)) _a.call(reversedResolvers_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 8: throw new Error("Could not load file \"" + pathAbsolute + "\"");
                }
            });
        });
    };
    /**
     * Get the list of errors for the entire program. It's calculated on the fly
     * by walking through every file, so call this sparingly.
     */
    Program.prototype.getDiagnostics = function () {
        var e_2, _a;
        var errorLists = [this.diagnostics];
        for (var contextName in this.contexts) {
            var context_1 = this.contexts[contextName];
            errorLists.push(context_1.getDiagnostics());
        }
        var allDiagnistics = Array.prototype.concat.apply([], errorLists);
        var finalDiagnostics = [];
        try {
            for (var allDiagnistics_1 = __values(allDiagnistics), allDiagnistics_1_1 = allDiagnistics_1.next(); !allDiagnistics_1_1.done; allDiagnistics_1_1 = allDiagnistics_1.next()) {
                var diagnostic = allDiagnistics_1_1.value;
                //skip duplicate diagnostics (by reference). This skips file parse diagnostics when multiple contexts include same file
                if (finalDiagnostics.indexOf(diagnostic) > -1) {
                    continue;
                }
                //skip any specified error codes
                if (this.options.ignoreErrorCodes.indexOf(diagnostic.code) > -1) {
                    continue;
                }
                //add the diagnostic to the final list
                finalDiagnostics.push(diagnostic);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (allDiagnistics_1_1 && !allDiagnistics_1_1.done && (_a = allDiagnistics_1.return)) _a.call(allDiagnistics_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return finalDiagnostics;
    };
    /**
     * Determine if the specified file is loaded in this program right now.
     * @param filePath
     */
    Program.prototype.hasFile = function (filePath) {
        filePath = util_1.default.normalizeFilePath(filePath);
        return this.files[filePath] !== undefined;
    };
    /**
     * Add and parse all of the provided files.
     * Files that are already loaded will be replaced by the latest
     * contents from the file system.
     * @param filePaths
     */
    Program.prototype.addOrReplaceFiles = function (filePaths) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Promise.all(filePaths.map(function (filePath) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, this.addOrReplaceFile(filePath)];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); }))];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Load a file into the program. If that file already exists, it is replaced.
     * If file contents are provided, those are used, Otherwise, the file is loaded from the file system
     * @param pathAbsolute
     * @param fileContents
     */
    Program.prototype.addOrReplaceFile = function (pathAbsolute, fileContents) {
        return __awaiter(this, void 0, void 0, function () {
            var pkgPath, fileExtension, file, brsFile, xmlFile, context_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        pathAbsolute = util_1.default.normalizeFilePath(pathAbsolute);
                        if (!(fileContents === undefined)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.getFileContents(pathAbsolute)];
                    case 1:
                        fileContents = _a.sent();
                        _a.label = 2;
                    case 2:
                        //if the file is already loaded, remove it
                        if (this.hasFile(pathAbsolute)) {
                            this.removeFile(pathAbsolute);
                        }
                        pkgPath = pathAbsolute.replace(this.rootDir + path.sep, '');
                        fileExtension = path.extname(pathAbsolute).toLowerCase();
                        if (!(fileExtension === '.brs' || fileExtension === '.bs')) return [3 /*break*/, 4];
                        brsFile = this.files[pathAbsolute] = new BrsFile_1.BrsFile(pathAbsolute, pkgPath, this);
                        return [4 /*yield*/, brsFile.parse(fileContents)];
                    case 3:
                        _a.sent();
                        file = brsFile;
                        return [3 /*break*/, 6];
                    case 4:
                        if (!(fileExtension === '.xml')) return [3 /*break*/, 6];
                        xmlFile = this.files[pathAbsolute] = new XmlFile_1.XmlFile(pathAbsolute, pkgPath, this);
                        return [4 /*yield*/, xmlFile.parse(fileContents)];
                    case 5:
                        _a.sent();
                        file = xmlFile;
                        context_2 = new XmlContext_1.XmlContext(xmlFile);
                        //attach this program to the new context
                        context_2.attachProgram(this);
                        //if the context doesn't have a parent context, give it the platform context
                        if (!context_2.parentContext) {
                            context_2.parentContext = this.platformContext;
                        }
                        this.contexts[context_2.name] = context_2;
                        return [3 /*break*/, 6];
                    case 6:
                        //notify all listeners about this file change
                        this.emit('file-added', file);
                        return [2 /*return*/, file];
                }
            });
        });
    };
    Program.prototype.on = function (name, callback) {
        var _this = this;
        this.emitter.on(name, callback);
        return function () {
            _this.emitter.removeListener(name, callback);
        };
    };
    Program.prototype.emit = function (name, data) {
        this.emitter.emit(name, data);
    };
    /**
     * Get a file with the specified pkg path.
     * If not found, return undefined
     */
    Program.prototype.getFileByPkgPath = function (pkgPath) {
        for (var filePath in this.files) {
            var file = this.files[filePath];
            if (file.pkgPath === pkgPath) {
                return file;
            }
        }
    };
    /**
     * Remove a set of files from the program
     * @param filePaths
     */
    Program.prototype.removeFiles = function (filePaths) {
        var e_3, _a;
        try {
            for (var filePaths_1 = __values(filePaths), filePaths_1_1 = filePaths_1.next(); !filePaths_1_1.done; filePaths_1_1 = filePaths_1.next()) {
                var filePath = filePaths_1_1.value;
                this.removeFile(filePath);
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (filePaths_1_1 && !filePaths_1_1.done && (_a = filePaths_1.return)) _a.call(filePaths_1);
            }
            finally { if (e_3) throw e_3.error; }
        }
    };
    /**
     * Remove a file from the program
     * @param filePath
     */
    Program.prototype.removeFile = function (filePath) {
        filePath = path.normalize(filePath);
        var file = this.files[filePath];
        //notify every context of this file removal
        for (var contextName in this.contexts) {
            var context_3 = this.contexts[contextName];
            context_3.removeFile(file);
        }
        //if there is a context named the same as this file's path, remove it (i.e. xml contexts)
        var context = this.contexts[file.pkgPath];
        if (context) {
            context.dispose();
            delete this.contexts[file.pkgPath];
        }
        //remove the file from the program
        delete this.files[filePath];
        this.emit('file-removed', file);
    };
    /**
     * Traverse the entire project, and validate all contexts
     */
    Program.prototype.validate = function () {
        return __awaiter(this, void 0, void 0, function () {
            var contextName, context_4, filePath, file, contextName;
            return __generator(this, function (_a) {
                this.diagnostics = [];
                for (contextName in this.contexts) {
                    context_4 = this.contexts[contextName];
                    context_4.validate();
                }
                //find any files NOT loaded into a context
                outer: for (filePath in this.files) {
                    file = this.files[filePath];
                    for (contextName in this.contexts) {
                        if (this.contexts[contextName].hasFile(file)) {
                            continue outer;
                        }
                    }
                    //if we got here, the file is not loaded in any context
                    this.diagnostics.push(__assign({ file: file, location: vscode_languageserver_1.Range.create(0, 0, 0, Number.MAX_VALUE), severity: 'warning' }, DiagnosticMessages_1.diagnosticMessages.File_not_referenced_by_any_file_1013()));
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Get the file at the given path
     * @param pathAbsolute
     */
    Program.prototype.getFile = function (pathAbsolute) {
        pathAbsolute = path.resolve(pathAbsolute);
        return this.files[pathAbsolute];
    };
    /**
     * Get a list of all contexts the file is loaded into
     * @param file
     */
    Program.prototype.getContextsForFile = function (file) {
        var result = [];
        for (var key in this.contexts) {
            var context_5 = this.contexts[key];
            if (context_5.hasFile(file)) {
                result.push(context_5);
            }
        }
        return result;
    };
    /**
     * Find all available completion items at the given position
     * @param pathAbsolute
     * @param lineIndex
     * @param columnIndex
     */
    Program.prototype.getCompletions = function (pathAbsolute, position) {
        var completions = [];
        var file = this.getFile(pathAbsolute);
        if (!file) {
            return [];
        }
        //find the contexts for this file (hopefully there's only one)
        var contexts = this.getContextsForFile(file);
        if (contexts.length > 1) {
            //TODO - make the user choose which context to use.
        }
        var context = contexts[0];
        var fileResult = file.getCompletions(position, context);
        completions.push.apply(completions, __spread(fileResult.completions));
        if (fileResult.includeContextCallables) {
            completions.push.apply(completions, __spread(context.getCallablesAsCompletions()));
        }
        return completions;
    };
    /**
     * Given a position in a file, if the position is sitting on some type of identifier,
     * go to the definition of that identifier (where this thing was first defined)
     */
    Program.prototype.getDefinition = function (pathAbsolute, position) {
        var e_4, _a;
        var file = this.getFile(pathAbsolute);
        if (!file) {
            return [];
        }
        var results = [];
        var contexts = this.getContextsForFile(file);
        try {
            for (var contexts_1 = __values(contexts), contexts_1_1 = contexts_1.next(); !contexts_1_1.done; contexts_1_1 = contexts_1.next()) {
                var context_6 = contexts_1_1.value;
                results = results.concat.apply(results, __spread(context_6.getDefinition(file, position)));
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (contexts_1_1 && !contexts_1_1.done && (_a = contexts_1.return)) _a.call(contexts_1);
            }
            finally { if (e_4) throw e_4.error; }
        }
        return results;
    };
    Program.prototype.getHover = function (pathAbsolute, position) {
        //find the file
        var file = this.getFile(pathAbsolute);
        if (!file) {
            return null;
        }
        return file.getHover(position);
    };
    Program.prototype.dispose = function () {
        this.emitter.removeAllListeners();
        for (var filePath in this.files) {
            this.files[filePath].dispose();
        }
        for (var name in this.contexts) {
            this.contexts[name].dispose();
        }
        this.platformContext.dispose();
    };
    return Program;
}());
exports.Program = Program;
//# sourceMappingURL=Program.js.map