"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = require("chalk");
var debounce = require("debounce-promise");
var path = require("path");
var rokuDeploy = require("roku-deploy");
var vscode_languageserver_1 = require("vscode-languageserver");
var vscode_uri_1 = require("vscode-uri");
var Program_1 = require("./Program");
var util_1 = require("./util");
var Watcher_1 = require("./Watcher");
/**
 * A runner class that handles
 */
var ProgramBuilder = /** @class */ (function () {
    function ProgramBuilder() {
        /**
         * Determines whether the console should be cleared after a run (true for cli, false for languageserver)
         */
        this.allowConsoleClearing = true;
        this.isRunning = false;
        this.fileResolvers = [];
        /**
         * A method that is used to cancel a previous run task.
         * Does nothing if previous run has completed or was already canceled
         */
        this.cancelLastRun = function () { return Promise.resolve(); };
    }
    ProgramBuilder.prototype.addFileResolver = function (fileResolver) {
        this.fileResolvers.push(fileResolver);
        if (this.program) {
            this.program.fileResolvers.push(fileResolver);
        }
    };
    /**
     * The list of errors found in the program.
     */
    ProgramBuilder.prototype.getDiagnostics = function () {
        return this.program.getDiagnostics();
    };
    ProgramBuilder.prototype.run = function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (this.isRunning) {
                            throw new Error('Server is already running');
                        }
                        _b = this;
                        return [4 /*yield*/, util_1.default.normalizeAndResolveConfig(options)];
                    case 1:
                        _b.options = _c.sent();
                        this.program = new Program_1.Program(this.options);
                        //add the initial FileResolvers
                        (_a = this.program.fileResolvers).push.apply(_a, __spread(this.fileResolvers));
                        //parse every file in the entire project
                        return [4 /*yield*/, this.loadAllFilesAST()];
                    case 2:
                        //parse every file in the entire project
                        _c.sent();
                        if (!this.options.watch) return [3 /*break*/, 5];
                        util_1.default.log('Starting compilation in watch mode...');
                        return [4 /*yield*/, this.runOnce()];
                    case 3:
                        _c.sent();
                        return [4 /*yield*/, this.enableWatchMode()];
                    case 4:
                        _c.sent();
                        return [3 /*break*/, 7];
                    case 5: return [4 /*yield*/, this.runOnce()];
                    case 6:
                        _c.sent();
                        _c.label = 7;
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
    ProgramBuilder.prototype.clearConsole = function () {
        if (this.allowConsoleClearing) {
            util_1.default.clearConsole();
        }
    };
    ProgramBuilder.prototype.enableWatchMode = function () {
        return __awaiter(this, void 0, void 0, function () {
            var e_1, _a, fileObjects, fileObjects_1, fileObjects_1_1, fileObject, debouncedRunOnce;
            var _this = this;
            return __generator(this, function (_b) {
                this.watcher = new Watcher_1.Watcher(this.options);
                //keep the process alive indefinitely by setting an interval that runs once every 12 days
                setInterval(function () { }, 1073741824);
                //clear the console
                this.clearConsole();
                fileObjects = rokuDeploy.normalizeFilesOption(this.options.files ? this.options.files : []);
                try {
                    //add each set of files to the file watcher
                    for (fileObjects_1 = __values(fileObjects), fileObjects_1_1 = fileObjects_1.next(); !fileObjects_1_1.done; fileObjects_1_1 = fileObjects_1.next()) {
                        fileObject = fileObjects_1_1.value;
                        this.watcher.watch(fileObject.src);
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (fileObjects_1_1 && !fileObjects_1_1.done && (_a = fileObjects_1.return)) _a.call(fileObjects_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                util_1.default.log('Watching for file changes...');
                debouncedRunOnce = debounce(function () { return __awaiter(_this, void 0, void 0, function () {
                    var errorCount;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                util_1.default.log('File change detected. Starting incremental compilation...');
                                return [4 /*yield*/, this.runOnce()];
                            case 1:
                                _a.sent();
                                errorCount = this.getDiagnostics().length;
                                util_1.default.log("Found " + errorCount + " errors. Watching for file changes.");
                                return [2 /*return*/];
                        }
                    });
                }); }, 50);
                //on any file watcher event
                this.watcher.on('all', function (event, path) { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                if (!(event === 'add' || event === 'change')) return [3 /*break*/, 2];
                                return [4 /*yield*/, this.program.addOrReplaceFile(path)];
                            case 1:
                                _a.sent();
                                return [3 /*break*/, 3];
                            case 2:
                                if (event === 'unlink') {
                                    this.program.removeFile(path);
                                }
                                _a.label = 3;
                            case 3:
                                //wait for change events to settle, and then execute `run`
                                debouncedRunOnce();
                                return [2 /*return*/];
                        }
                    });
                }); });
                return [2 /*return*/];
            });
        });
    };
    /**
     * Run the entire process exactly one time.
     */
    ProgramBuilder.prototype.runOnce = function () {
        var _this = this;
        //clear the console
        this.clearConsole();
        var cancellationToken = { isCanceled: false };
        //wait for the previous run to complete
        var runPromise = this.cancelLastRun().then(function () {
            //start the new run
            return _this._runOnce(cancellationToken);
        }).then(function () {
            //track if the run completed
            return _this.printDiagnostics();
        }, function (err) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.printDiagnostics()];
                    case 1:
                        _a.sent();
                        //track if the run completed
                        throw err;
                }
            });
        }); });
        //a function used to cancel this run
        this.cancelLastRun = function () {
            cancellationToken.isCanceled = true;
            return runPromise;
        };
        return runPromise;
    };
    ProgramBuilder.prototype.printDiagnostics = function () {
        return __awaiter(this, void 0, void 0, function () {
            var e_2, _a, e_3, _b, e_4, _c, diagnostics, diagnosticsByFile, diagnostics_1, diagnostics_1_1, diagnostic, cwd, pathsAbsolute, pathsAbsolute_1, pathsAbsolute_1_1, pathAbsolute, diagnosticsForFile, sortedDiagnostics, filePath, typeColor, fileText, lines, sortedDiagnostics_1, sortedDiagnostics_1_1, diagnostic, diagnosticLine, squigglyLength, lineNumberText, e_3_1;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        diagnostics = this.getDiagnostics();
                        diagnosticsByFile = {};
                        try {
                            for (diagnostics_1 = __values(diagnostics), diagnostics_1_1 = diagnostics_1.next(); !diagnostics_1_1.done; diagnostics_1_1 = diagnostics_1.next()) {
                                diagnostic = diagnostics_1_1.value;
                                if (!diagnosticsByFile[diagnostic.file.pathAbsolute]) {
                                    diagnosticsByFile[diagnostic.file.pathAbsolute] = [];
                                }
                                diagnosticsByFile[diagnostic.file.pathAbsolute].push(diagnostic);
                            }
                        }
                        catch (e_2_1) { e_2 = { error: e_2_1 }; }
                        finally {
                            try {
                                if (diagnostics_1_1 && !diagnostics_1_1.done && (_a = diagnostics_1.return)) _a.call(diagnostics_1);
                            }
                            finally { if (e_2) throw e_2.error; }
                        }
                        cwd = this.options.cwd ? this.options.cwd : process.cwd();
                        pathsAbsolute = Object.keys(diagnosticsByFile).sort();
                        _d.label = 1;
                    case 1:
                        _d.trys.push([1, 6, 7, 8]);
                        pathsAbsolute_1 = __values(pathsAbsolute), pathsAbsolute_1_1 = pathsAbsolute_1.next();
                        _d.label = 2;
                    case 2:
                        if (!!pathsAbsolute_1_1.done) return [3 /*break*/, 5];
                        pathAbsolute = pathsAbsolute_1_1.value;
                        diagnosticsForFile = diagnosticsByFile[pathAbsolute];
                        sortedDiagnostics = diagnosticsForFile.sort(function (a, b) {
                            return (a.location.start.line - b.location.start.line ||
                                a.location.start.character - b.location.start.character);
                        });
                        filePath = pathAbsolute;
                        typeColor = {
                            information: chalk_1.default.blue,
                            hint: chalk_1.default.green,
                            warning: chalk_1.default.yellow,
                            error: chalk_1.default.red,
                        };
                        if (this.options.emitFullPaths !== true) {
                            filePath = path.relative(cwd, filePath);
                        }
                        return [4 /*yield*/, util_1.default.getFileContents(pathAbsolute)];
                    case 3:
                        fileText = _d.sent();
                        lines = util_1.default.getLines(fileText);
                        try {
                            for (sortedDiagnostics_1 = __values(sortedDiagnostics), sortedDiagnostics_1_1 = sortedDiagnostics_1.next(); !sortedDiagnostics_1_1.done; sortedDiagnostics_1_1 = sortedDiagnostics_1.next()) {
                                diagnostic = sortedDiagnostics_1_1.value;
                                console.log('');
                                console.log(chalk_1.default.cyan(filePath) +
                                    ':' +
                                    chalk_1.default.yellow((diagnostic.location.start.line + 1) +
                                        ':' +
                                        (diagnostic.location.start.character + 1)) +
                                    ' - ' +
                                    typeColor[diagnostic.severity](diagnostic.severity) +
                                    ' ' +
                                    chalk_1.default.grey('BRS' + diagnostic.code) +
                                    ': ' +
                                    chalk_1.default.white(diagnostic.message));
                                console.log('');
                                diagnosticLine = lines[diagnostic.location.start.line];
                                squigglyLength = diagnostic.location.end.character - diagnostic.location.start.character;
                                if (squigglyLength > diagnosticLine.length - diagnostic.location.start.character) {
                                    squigglyLength = diagnosticLine.length - diagnostic.location.end.character;
                                }
                                lineNumberText = chalk_1.default.bgWhite(' ' + chalk_1.default.black((diagnostic.location.start.line + 1).toString()) + ' ') + ' ';
                                console.log(lineNumberText + diagnosticLine);
                                console.log(lineNumberText +
                                    typeColor[diagnostic.severity](util_1.default.padLeft('', diagnostic.location.start.character, ' ') +
                                        //print squigglies
                                        util_1.default.padLeft('', squigglyLength, '~')));
                                console.log('');
                            }
                        }
                        catch (e_4_1) { e_4 = { error: e_4_1 }; }
                        finally {
                            try {
                                if (sortedDiagnostics_1_1 && !sortedDiagnostics_1_1.done && (_c = sortedDiagnostics_1.return)) _c.call(sortedDiagnostics_1);
                            }
                            finally { if (e_4) throw e_4.error; }
                        }
                        _d.label = 4;
                    case 4:
                        pathsAbsolute_1_1 = pathsAbsolute_1.next();
                        return [3 /*break*/, 2];
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        e_3_1 = _d.sent();
                        e_3 = { error: e_3_1 };
                        return [3 /*break*/, 8];
                    case 7:
                        try {
                            if (pathsAbsolute_1_1 && !pathsAbsolute_1_1.done && (_b = pathsAbsolute_1.return)) _b.call(pathsAbsolute_1);
                        }
                        finally { if (e_3) throw e_3.error; }
                        return [7 /*endfinally*/];
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Run the process once, allowing cancelability.
     * NOTE: This should only be called by `runOnce`.
     * @param cancellationToken
     */
    ProgramBuilder.prototype._runOnce = function (cancellationToken) {
        return __awaiter(this, void 0, void 0, function () {
            var errorCount;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        //maybe cancel?
                        if (cancellationToken.isCanceled === true) {
                            return [2 /*return*/, -1];
                        }
                        //validate program
                        return [4 /*yield*/, this.validateProject()];
                    case 1:
                        //validate program
                        _a.sent();
                        errorCount = this.getDiagnostics().length;
                        //maybe cancel?
                        if (cancellationToken.isCanceled === true) {
                            return [2 /*return*/, -1];
                        }
                        if (errorCount > 0) {
                            return [2 /*return*/, errorCount];
                        }
                        //create the deployment package
                        return [4 /*yield*/, this.createPackageIfEnabled()];
                    case 2:
                        //create the deployment package
                        _a.sent();
                        //maybe cancel?
                        if (cancellationToken.isCanceled === true) {
                            return [2 /*return*/, -1];
                        }
                        //deploy the package
                        return [4 /*yield*/, this.deployPackageIfEnabled()];
                    case 3:
                        //deploy the package
                        _a.sent();
                        return [2 /*return*/, 0];
                }
            });
        });
    };
    ProgramBuilder.prototype.createPackageIfEnabled = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this.options.skipPackage === false || this.options.deploy)) return [3 /*break*/, 2];
                        util_1.default.log("Creating package at " + this.options.outFile);
                        return [4 /*yield*/, rokuDeploy.createPackage(__assign({}, this.options, { outDir: util_1.default.getOutDir(this.options), outFile: path.basename(this.options.outFile) }))];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    ProgramBuilder.prototype.deployPackageIfEnabled = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.options.deploy) return [3 /*break*/, 2];
                        util_1.default.log("Deploying package to " + this.options.host);
                        return [4 /*yield*/, rokuDeploy.publish(__assign({}, this.options, { outDir: util_1.default.getOutDir(this.options), outFile: path.basename(this.options.outFile) }))];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Parse and load the AST for every file in the project
     */
    ProgramBuilder.prototype.loadAllFilesAST = function () {
        return __awaiter(this, void 0, void 0, function () {
            var errorCount, files;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        errorCount = 0;
                        return [4 /*yield*/, util_1.default.getFilePaths(this.options)];
                    case 1:
                        files = _a.sent();
                        //parse every file
                        return [4 /*yield*/, Promise.all(files.map(function (file) { return __awaiter(_this, void 0, void 0, function () {
                                var fileExtension, e_5;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            _a.trys.push([0, 3, , 4]);
                                            fileExtension = path.extname(file.src).toLowerCase();
                                            if (!(['.bs', '.brs', '.xml'].indexOf(fileExtension) > -1)) return [3 /*break*/, 2];
                                            return [4 /*yield*/, this.program.addOrReplaceFile(file.src)];
                                        case 1:
                                            _a.sent();
                                            _a.label = 2;
                                        case 2: return [3 /*break*/, 4];
                                        case 3:
                                            e_5 = _a.sent();
                                            //log the error, but don't fail this process because the file might be fixable later
                                            console.error(e_5);
                                            return [3 /*break*/, 4];
                                        case 4: return [2 /*return*/];
                                    }
                                });
                            }); }))];
                    case 2:
                        //parse every file
                        _a.sent();
                        return [2 /*return*/, errorCount];
                }
            });
        });
    };
    /**
     * This only operates on files that match the specified files globs, so it is safe to throw
     * any file changes you receive with no unexpected side-effects
     * @param changes
     */
    ProgramBuilder.prototype.handleFileChanges = function (changes) {
        return __awaiter(this, void 0, void 0, function () {
            var e_6, _a, matchingFilePathsPromise, getMatchingFilePaths, changes_1, changes_1_1, change, pathAbsolute, filePaths, e_6_1;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        getMatchingFilePaths = function () {
                            if (!matchingFilePathsPromise) {
                                matchingFilePathsPromise = util_1.default.getFilePaths(_this.options).then(function (fileObjects) {
                                    return fileObjects.map(function (obj) { return obj.src; });
                                });
                            }
                            return matchingFilePathsPromise;
                        };
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 16, 17, 18]);
                        changes_1 = __values(changes), changes_1_1 = changes_1.next();
                        _b.label = 2;
                    case 2:
                        if (!!changes_1_1.done) return [3 /*break*/, 15];
                        change = changes_1_1.value;
                        pathAbsolute = path.normalize(vscode_uri_1.default.parse(change.uri).fsPath);
                        if (!(change.type === vscode_languageserver_1.FileChangeType.Deleted)) return [3 /*break*/, 4];
                        //try to act on this path as a directory
                        return [4 /*yield*/, this.removeFilesInFolder(pathAbsolute)];
                    case 3:
                        //try to act on this path as a directory
                        _b.sent();
                        //if this is a file loaded in the program, remove it
                        if (this.program.hasFile(pathAbsolute)) {
                            this.program.removeFile(pathAbsolute);
                        }
                        return [3 /*break*/, 14];
                    case 4:
                        if (!(change.type === vscode_languageserver_1.FileChangeType.Created)) return [3 /*break*/, 9];
                        //load all matching missing files from this path (if it's a directory)
                        return [4 /*yield*/, this.loadMissingFilesFromFolder(pathAbsolute)];
                    case 5:
                        //load all matching missing files from this path (if it's a directory)
                        _b.sent();
                        return [4 /*yield*/, getMatchingFilePaths()];
                    case 6:
                        filePaths = _b.sent();
                        if (!filePaths.indexOf(pathAbsolute)) return [3 /*break*/, 8];
                        return [4 /*yield*/, this.program.addOrReplaceFile(pathAbsolute)];
                    case 7:
                        _b.sent();
                        _b.label = 8;
                    case 8: return [3 /*break*/, 14];
                    case 9:
                        if (!this.program.hasFile(pathAbsolute)) return [3 /*break*/, 14];
                        return [4 /*yield*/, util_1.default.fileExists(pathAbsolute)];
                    case 10:
                        if (!_b.sent()) return [3 /*break*/, 12];
                        return [4 /*yield*/, this.program.addOrReplaceFile(pathAbsolute)];
                    case 11:
                        _b.sent();
                        return [3 /*break*/, 14];
                    case 12: return [4 /*yield*/, this.program.removeFile(pathAbsolute)];
                    case 13:
                        _b.sent();
                        _b.label = 14;
                    case 14:
                        changes_1_1 = changes_1.next();
                        return [3 /*break*/, 2];
                    case 15: return [3 /*break*/, 18];
                    case 16:
                        e_6_1 = _b.sent();
                        e_6 = { error: e_6_1 };
                        return [3 /*break*/, 18];
                    case 17:
                        try {
                            if (changes_1_1 && !changes_1_1.done && (_a = changes_1.return)) _a.call(changes_1);
                        }
                        finally { if (e_6) throw e_6.error; }
                        return [7 /*endfinally*/];
                    case 18: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Remove all files from the program that are in the specified folder path
     * @param folderPathAbsolute
     */
    ProgramBuilder.prototype.removeFilesInFolder = function (folderPathAbsolute) {
        return __awaiter(this, void 0, void 0, function () {
            var filePath;
            return __generator(this, function (_a) {
                for (filePath in this.program.files) {
                    //if the file path starts with the parent path and the file path does not exactly match the folder path
                    if (filePath.indexOf(folderPathAbsolute) === 0 && filePath !== folderPathAbsolute) {
                        this.program.removeFile(filePath);
                    }
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Load any files from the given folder that are not already loaded into the program.
     * This is mainly used when folders get moved, but we also have some active changes in
     * some of the files from the new location already
     * @param folderPathAbsolute
     */
    ProgramBuilder.prototype.loadMissingFilesFromFolder = function (folderPathAbsolute) {
        return __awaiter(this, void 0, void 0, function () {
            var e_7, _a, allFilesObjects, promises, allFilesObjects_1, allFilesObjects_1_1, fileObj;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        folderPathAbsolute = path.normalize(folderPathAbsolute);
                        return [4 /*yield*/, util_1.default.getFilePaths(this.options)];
                    case 1:
                        allFilesObjects = _b.sent();
                        promises = [];
                        try {
                            //for every matching file
                            for (allFilesObjects_1 = __values(allFilesObjects), allFilesObjects_1_1 = allFilesObjects_1.next(); !allFilesObjects_1_1.done; allFilesObjects_1_1 = allFilesObjects_1.next()) {
                                fileObj = allFilesObjects_1_1.value;
                                if (
                                //file path starts with folder path
                                fileObj.src.indexOf(folderPathAbsolute) === 0 &&
                                    //paths are not identical (solves problem when passing file path into this method instead of folder path)
                                    fileObj.src !== folderPathAbsolute &&
                                    this.program.hasFile(fileObj.src) === false) {
                                    promises.push(this.program.addOrReplaceFile(fileObj.src));
                                }
                            }
                        }
                        catch (e_7_1) { e_7 = { error: e_7_1 }; }
                        finally {
                            try {
                                if (allFilesObjects_1_1 && !allFilesObjects_1_1.done && (_a = allFilesObjects_1.return)) _a.call(allFilesObjects_1);
                            }
                            finally { if (e_7) throw e_7.error; }
                        }
                        return [4 /*yield*/, Promise.all(promises)];
                    case 2:
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Scan every file and resolve all variable references.
     * If no errors were encountered, return true. Otherwise return false.
     */
    ProgramBuilder.prototype.validateProject = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.program.validate()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    ProgramBuilder.prototype.dispose = function () {
        if (this.watcher) {
            this.watcher.dispose();
        }
        this.program.dispose();
    };
    return ProgramBuilder;
}());
exports.ProgramBuilder = ProgramBuilder;
//# sourceMappingURL=ProgramBuilder.js.map