"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var chokidar = require("chokidar");
/**
 * There are some bugs with chokidar, so this attempts to mitigate them
 */
var Watcher = /** @class */ (function () {
    function Watcher(options) {
        this.options = options;
        this.watchers = [];
    }
    /**
     * Watch the paths or globs
     * @param paths
     */
    Watcher.prototype.watch = function (paths) {
        var _this = this;
        var watcher = chokidar.watch(paths, {
            cwd: this.options.rootDir,
            ignoreInitial: true,
            awaitWriteFinish: {
                stabilityThreshold: 200,
                pollInterval: 100
            }
        });
        this.watchers.push(watcher);
        return function () {
            //unwatch all paths
            watcher.unwatch(paths);
            //close the watcher
            watcher.close();
            //remove the watcher from our list
            _this.watchers.splice(_this.watchers.indexOf(watcher), 1);
        };
    };
    /**
     * Be notified of all events
     * @param event
     * @param callback
     */
    Watcher.prototype.on = function (event, callback) {
        var e_1, _a;
        var watchers = __spread(this.watchers);
        try {
            for (var watchers_1 = __values(watchers), watchers_1_1 = watchers_1.next(); !watchers_1_1.done; watchers_1_1 = watchers_1.next()) {
                var watcher = watchers_1_1.value;
                watcher.on(event, cb);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (watchers_1_1 && !watchers_1_1.done && (_a = watchers_1.return)) _a.call(watchers_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        function cb(event, path, details) {
            callback(event, path, details);
        }
        //a disconnect function
        return function () {
            var e_2, _a;
            try {
                for (var watchers_2 = __values(watchers), watchers_2_1 = watchers_2.next(); !watchers_2_1.done; watchers_2_1 = watchers_2.next()) {
                    var watcher = watchers_2_1.value;
                    watcher.removeListener('all', cb);
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (watchers_2_1 && !watchers_2_1.done && (_a = watchers_2.return)) _a.call(watchers_2);
                }
                finally { if (e_2) throw e_2.error; }
            }
        };
    };
    Watcher.prototype.dispose = function () {
        var e_3, _a;
        try {
            for (var _b = __values(this.watchers), _c = _b.next(); !_c.done; _c = _b.next()) {
                var watcher = _c.value;
                watcher.removeAllListeners();
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_3) throw e_3.error; }
        }
    };
    return Watcher;
}());
exports.Watcher = Watcher;
//# sourceMappingURL=Watcher.js.map