import { Location, Position } from 'vscode-languageserver';
import { Context } from './Context';
import { BrsFile } from './files/BrsFile';
import { XmlFile } from './files/XmlFile';
import { Program } from './Program';
export declare class XmlContext extends Context {
    constructor(xmlFile: XmlFile);
    attachProgram(program: Program): void;
    /**
     * Event handler for when the attached program removes a file
     * @param file
     */
    private onProgramFileRemove;
    private handleXmlFileParentAttach;
    private addParentIfMatch;
    validate(): void;
    /**
     * Detect when a child has imported a script that an ancestor also imported
     */
    private diagnosticDetectDuplicateAncestorScriptImports;
    /**
     * Get the definition (where was this thing first defined) of the symbol under the position
     */
    getDefinition(file: BrsFile | XmlFile, position: Position): Location[];
    /**
     * Verify that all of the scripts ipmorted by
     */
    private diagnosticValidateScriptImportPaths;
    private xmlFileHandles;
    private xmlFile;
    dispose(): void;
}
