"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var brs = require("brs");
var Lexeme = brs.lexer.Lexeme;
var path = require("path");
var vscode_languageserver_1 = require("vscode-languageserver");
var DiagnosticMessages_1 = require("../DiagnosticMessages");
var FunctionScope_1 = require("../FunctionScope");
var DynamicType_1 = require("../types/DynamicType");
var FunctionType_1 = require("../types/FunctionType");
var StringType_1 = require("../types/StringType");
var VoidType_1 = require("../types/VoidType");
var util_1 = require("../util");
/**
 * Holds all details about this file within the context of the whole program
 */
var BrsFile = /** @class */ (function () {
    function BrsFile(pathAbsolute, 
    /**
     * The absolute path to the file, relative to the pkg
     */
    pkgPath, program) {
        this.pathAbsolute = pathAbsolute;
        this.pkgPath = pkgPath;
        this.program = program;
        /**
         * Indicates if this file was processed by the program yet.
         */
        this.wasProcessed = false;
        this.diagnostics = [];
        this.commentFlags = [];
        this.callables = [];
        this.functionCalls = [];
        this.functionScopes = [];
        this.tokens = [];
        this.scopesByFunc = new Map();
        this.extension = path.extname(pathAbsolute).toLowerCase();
    }
    BrsFile.prototype.getDiagnostics = function () {
        return __spread(this.diagnostics);
    };
    /**
     * Get the token at the specified position
     * @param position
     */
    BrsFile.prototype.getTokenAt = function (position) {
        var e_1, _a;
        try {
            for (var _b = __values(this.tokens), _c = _b.next(); !_c.done; _c = _b.next()) {
                var token = _c.value;
                if (util_1.default.rangeContains(util_1.default.locationToRange(token.location), position)) {
                    return token;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    /**
     * Calculate the AST for this file
     * @param fileContents
     */
    BrsFile.prototype.parse = function (fileContents) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, lines, lexResult, tokens, manifest, preprocessor, preprocessorResults, preprocessorWasSuccessful, handle, parser, parseResult, errors;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (this.wasProcessed) {
                            throw new Error("File was already processed. Create a new file instead. " + this.pathAbsolute);
                        }
                        lines = util_1.default.getLines(fileContents);
                        this.getIgnores(lines);
                        lexResult = brs.lexer.Lexer.scan(fileContents);
                        tokens = lexResult.tokens;
                        return [4 /*yield*/, brs.preprocessor.getManifest(this.program.rootDir)];
                    case 1:
                        manifest = _b.sent();
                        preprocessor = new brs.preprocessor.Preprocessor();
                        preprocessorResults = {
                            errors: [],
                            processedTokens: []
                        };
                        //currently the preprocessor throws exceptions on syntax errors...so we need to catch it
                        try {
                            handle = preprocessor.onError(function (err) {
                                preprocessorResults.errors.push(err);
                            });
                            preprocessorResults = preprocessor.preprocess(tokens, manifest);
                            preprocessorWasSuccessful = true;
                        }
                        catch (e) {
                            preprocessorWasSuccessful = false;
                            //if the thrown error is DIFFERENT than any errors from the preprocessor, add that error to the list as well
                            if (preprocessorResults.errors.find(function (ex) { return ex === e; }) === undefined) {
                                preprocessorResults.errors.push(e);
                            }
                        }
                        //dispose of the onError event listener
                        if (handle) {
                            handle.dispose();
                        }
                        //TODO have brs change the type of `processedTokens` to not be readonly array
                        this.tokens = preprocessorWasSuccessful ? preprocessorResults.processedTokens : lexResult.tokens;
                        parser = new brs.parser.Parser();
                        parseResult = parser.parse(this.tokens);
                        errors = __spread(lexResult.errors, parseResult.errors, preprocessorResults.errors);
                        //convert the brs library's errors into our format
                        (_a = this.diagnostics).push.apply(_a, __spread(this.standardizeLexParseErrors(errors, lines)));
                        this.ast = parseResult.statements;
                        //extract all callables from this file
                        this.findCallables(lines);
                        //traverse the ast and find all functions and create a scope object
                        this.createFunctionScopes(lines, this.ast);
                        //find all places where a sub/function is being called
                        this.findFunctionCalls(lines);
                        this.wasProcessed = true;
                        return [2 /*return*/];
                }
            });
        });
    };
    BrsFile.prototype.standardizeLexParseErrors = function (errors, lines) {
        var e_2, _a;
        var standardizedDiagnostics = [];
        try {
            for (var errors_1 = __values(errors), errors_1_1 = errors_1.next(); !errors_1_1.done; errors_1_1 = errors_1.next()) {
                var error = errors_1_1.value;
                var diagnostic = {
                    code: 1000,
                    location: util_1.default.locationToRange(error.location),
                    file: this,
                    severity: 'error',
                    message: error.message
                };
                standardizedDiagnostics.push(diagnostic);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (errors_1_1 && !errors_1_1.done && (_a = errors_1.return)) _a.call(errors_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return standardizedDiagnostics;
    };
    /**
     * Find all comment flags in the source code. These enable or disable diagnostic messages.
     * @param lines - the lines of the program
     */
    BrsFile.prototype.getIgnores = function (lines) {
        var allCodesExcept1014 = DiagnosticMessages_1.diagnosticCodes.filter(function (x) { return x !== DiagnosticMessages_1.diagnosticMessages.Unknown_diagnostic_code_1014(0).code; });
        this.commentFlags = [];
        var _loop_1 = function (lineIndex) {
            var e_3, _a, e_4, _b;
            var line = lines[lineIndex];
            var nextLineLength = lines[lineIndex + 1] ? lines[lineIndex + 1].length : Number.MAX_SAFE_INTEGER;
            //brs:disable-next-line and brs:disable-line
            {
                var searches = [{
                        text: "'brs:disable-next-line",
                        lineOffset: 1,
                        getAffectedRange: function () {
                            return vscode_languageserver_1.Range.create(lineIndex + 1, 0, lineIndex + 1, nextLineLength);
                        }
                    }, {
                        text: "'brs:disable-line",
                        lineOffset: 0,
                        getAffectedRange: function (idx) {
                            return vscode_languageserver_1.Range.create(lineIndex, 0, lineIndex, idx);
                        }
                    }];
                try {
                    for (var searches_1 = __values(searches), searches_1_1 = searches_1.next(); !searches_1_1.done; searches_1_1 = searches_1.next()) {
                        var search = searches_1_1.value;
                        //find the disable-next-line
                        var idx = line.indexOf(search.text);
                        if (idx > -1) {
                            var affectedRange = search.getAffectedRange(idx);
                            var stmt = line.substring(idx).trim();
                            stmt = stmt.replace(search.text, '');
                            stmt = stmt.trim();
                            var commentFlag = void 0;
                            //statement to disable EVERYTHING
                            if (stmt.length === 0) {
                                commentFlag = {
                                    file: this_1,
                                    //null means all codes
                                    codes: null,
                                    range: vscode_languageserver_1.Range.create(lineIndex, idx, lineIndex, idx + search.text.length),
                                    affectedRange: affectedRange
                                };
                                //disable specific rules on the next line
                            }
                            else if (stmt.indexOf(':') === 0) {
                                stmt = stmt.replace(':', '');
                                var codes = [];
                                //starting position + search.text length + 1 for the colon
                                var offset = idx + search.text.length + 1;
                                var codeTokens = util_1.default.tokenizeByWhitespace(stmt);
                                try {
                                    for (var codeTokens_1 = __values(codeTokens), codeTokens_1_1 = codeTokens_1.next(); !codeTokens_1_1.done; codeTokens_1_1 = codeTokens_1.next()) {
                                        var codeToken = codeTokens_1_1.value;
                                        var codeInt = parseInt(codeToken.text);
                                        //add a warning for unknown codes
                                        if (DiagnosticMessages_1.diagnosticCodes.indexOf(codeInt) === -1) {
                                            this_1.diagnostics.push(__assign({}, DiagnosticMessages_1.diagnosticMessages.Unknown_diagnostic_code_1014(codeInt), { file: this_1, location: vscode_languageserver_1.Range.create(lineIndex, offset + codeToken.startIndex, lineIndex, offset + codeToken.startIndex + codeToken.text.length), severity: 'warning' }));
                                        }
                                        else {
                                            codes.push(codeInt);
                                        }
                                    }
                                }
                                catch (e_4_1) { e_4 = { error: e_4_1 }; }
                                finally {
                                    try {
                                        if (codeTokens_1_1 && !codeTokens_1_1.done && (_b = codeTokens_1.return)) _b.call(codeTokens_1);
                                    }
                                    finally { if (e_4) throw e_4.error; }
                                }
                                if (codes.length > 0) {
                                    commentFlag = {
                                        file: this_1,
                                        codes: codes,
                                        range: vscode_languageserver_1.Range.create(lineIndex, idx, lineIndex, line.length),
                                        affectedRange: affectedRange,
                                    };
                                }
                            }
                            if (commentFlag) {
                                this_1.commentFlags.push(commentFlag);
                                //add an ignore for everything in this comment except for Unknown_diagnostic_code_1014
                                this_1.commentFlags.push({
                                    affectedRange: commentFlag.range,
                                    range: commentFlag.range,
                                    codes: allCodesExcept1014,
                                    file: this_1
                                });
                            }
                        }
                    }
                }
                catch (e_3_1) { e_3 = { error: e_3_1 }; }
                finally {
                    try {
                        if (searches_1_1 && !searches_1_1.done && (_a = searches_1.return)) _a.call(searches_1);
                    }
                    finally { if (e_3) throw e_3.error; }
                }
            }
        };
        var this_1 = this;
        for (var lineIndex = 0; lineIndex < lines.length; lineIndex++) {
            _loop_1(lineIndex);
        }
    };
    /**
     * Create a scope for every function in this file
     */
    BrsFile.prototype.createFunctionScopes = function (lines, statements, parent) {
        var e_5, _a, e_6, _b, e_7, _c;
        //find every function
        var functions = util_1.default.findAllDeep(this.ast, function (x) { return x instanceof brs.parser.Expr.Function; });
        try {
            //create a functionScope for every function
            for (var functions_1 = __values(functions), functions_1_1 = functions_1.next(); !functions_1_1.done; functions_1_1 = functions_1.next()) {
                var kvp = functions_1_1.value;
                var func = kvp.value;
                var scope = new FunctionScope_1.FunctionScope(func);
                var ancestors = this.getAncestors(statements, kvp.key);
                var parentFunc = void 0;
                //find parent function, and add this scope to it if found
                {
                    for (var i = ancestors.length - 1; i >= 0; i--) {
                        if (ancestors[i] instanceof brs.parser.Expr.Function) {
                            parentFunc = ancestors[i];
                            break;
                        }
                    }
                    var parentScope = this.scopesByFunc.get(parentFunc);
                    //add this child scope to its parent
                    if (parentScope) {
                        parentScope.childrenScopes.push(scope);
                    }
                    //store the parent scope for this scope
                    scope.parentScope = parentScope;
                }
                //compute the range of this func
                scope.bodyRange = util_1.default.getBodyRangeForFunc(func);
                scope.range = vscode_languageserver_1.Range.create(func.keyword.location.start.line - 1, func.keyword.location.start.column, func.end.location.end.line - 1, func.end.location.end.column);
                try {
                    //add every parameter
                    for (var _d = __values(func.parameters), _e = _d.next(); !_e.done; _e = _d.next()) {
                        var param = _e.value;
                        scope.variableDeclarations.push({
                            nameRange: util_1.default.locationToRange(param.name.location),
                            lineIndex: param.name.location.start.line - 1,
                            name: param.name.text,
                            type: util_1.default.valueKindToBrsType(param.type.kind)
                        });
                    }
                }
                catch (e_6_1) { e_6 = { error: e_6_1 }; }
                finally {
                    try {
                        if (_e && !_e.done && (_b = _d.return)) _b.call(_d);
                    }
                    finally { if (e_6) throw e_6.error; }
                }
                this.scopesByFunc.set(func, scope);
                //find every statement in the scope
                this.functionScopes.push(scope);
            }
        }
        catch (e_5_1) { e_5 = { error: e_5_1 }; }
        finally {
            try {
                if (functions_1_1 && !functions_1_1.done && (_a = functions_1.return)) _a.call(functions_1);
            }
            finally { if (e_5) throw e_5.error; }
        }
        //find every variable assignment in the whole file
        var assignmentStatements = util_1.default.findAllDeep(this.ast, function (x) { return x instanceof brs.parser.Stmt.Assignment; });
        try {
            for (var assignmentStatements_1 = __values(assignmentStatements), assignmentStatements_1_1 = assignmentStatements_1.next(); !assignmentStatements_1_1.done; assignmentStatements_1_1 = assignmentStatements_1.next()) {
                var kvp = assignmentStatements_1_1.value;
                var statement = kvp.value;
                var nameRange = util_1.default.locationToRange(statement.name.location);
                //find this statement's function scope
                var scope = this.getFunctionScopeAtPosition(nameRange.start);
                //skip variable declarations that are outside of any scope
                if (scope) {
                    scope.variableDeclarations.push({
                        nameRange: nameRange,
                        lineIndex: statement.name.location.start.line - 1,
                        name: statement.name.text,
                        type: this.getBRSTypeFromAssignment(statement, scope)
                    });
                }
            }
        }
        catch (e_7_1) { e_7 = { error: e_7_1 }; }
        finally {
            try {
                if (assignmentStatements_1_1 && !assignmentStatements_1_1.done && (_c = assignmentStatements_1.return)) _c.call(assignmentStatements_1);
            }
            finally { if (e_7) throw e_7.error; }
        }
    };
    /**
     * Given a set of statements and top-level ast,
     * find the closest function ancestor for the given key
     * @param statements
     * @param key
     */
    BrsFile.prototype.getAncestors = function (statements, key) {
        var e_8, _a;
        var parts = key.split('.');
        //throw out the last part, because that is already a func (it's the "child")
        parts.pop();
        var current = statements;
        var ancestors = [];
        try {
            for (var parts_1 = __values(parts), parts_1_1 = parts_1.next(); !parts_1_1.done; parts_1_1 = parts_1.next()) {
                var part = parts_1_1.value;
                current = current[part];
                ancestors.push(current);
            }
        }
        catch (e_8_1) { e_8 = { error: e_8_1 }; }
        finally {
            try {
                if (parts_1_1 && !parts_1_1.done && (_a = parts_1.return)) _a.call(parts_1);
            }
            finally { if (e_8) throw e_8.error; }
        }
        return ancestors;
    };
    BrsFile.prototype.getBRSTypeFromAssignment = function (assignment, scope) {
        var e_9, _a;
        try {
            //function
            if (assignment.value instanceof brs.parser.Expr.Function) {
                var functionType = new FunctionType_1.FunctionType(util_1.default.valueKindToBrsType(assignment.value.returns));
                functionType.isSub = assignment.value.keyword.text === 'sub';
                if (functionType.isSub) {
                    functionType.returnType = new VoidType_1.VoidType();
                }
                functionType.setName(assignment.name.text);
                try {
                    for (var _b = __values(assignment.value.parameters), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var argument = _c.value;
                        var isRequired = !argument.defaultValue;
                        //TODO compute optional parameters
                        functionType.addParameter(argument.name.text, util_1.default.valueKindToBrsType(argument.type.kind), isRequired);
                    }
                }
                catch (e_9_1) { e_9 = { error: e_9_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_9) throw e_9.error; }
                }
                return functionType;
                //literal
            }
            else if (assignment.value instanceof brs.parser.Expr.Literal) {
                return util_1.default.valueKindToBrsType(assignment.value.value.kind);
                //function call
            }
            else if (assignment.value instanceof brs.parser.Expr.Call) {
                var calleeName = assignment.value.callee.name.text;
                if (calleeName) {
                    var func = this.getCallableByName(calleeName);
                    if (func) {
                        return func.type.returnType;
                    }
                }
            }
            else if (assignment.value instanceof brs.parser.Expr.Variable) {
                var variableName = assignment.value.name.text;
                var variable = scope.getVariableByName(variableName);
                return variable.type;
            }
        }
        catch (e) {
            //do nothing. Just return dynamic
        }
        //fallback to dynamic
        return new DynamicType_1.DynamicType();
    };
    BrsFile.prototype.getCallableByName = function (name) {
        var e_10, _a;
        name = name ? name.toLowerCase() : undefined;
        if (!name) {
            return;
        }
        try {
            for (var _b = __values(this.callables), _c = _b.next(); !_c.done; _c = _b.next()) {
                var func = _c.value;
                if (func.name.toLowerCase() === name) {
                    return func;
                }
            }
        }
        catch (e_10_1) { e_10 = { error: e_10_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_10) throw e_10.error; }
        }
    };
    BrsFile.prototype.findCallables = function (lines) {
        var e_11, _a, e_12, _b;
        this.callables = [];
        try {
            for (var _c = __values(this.ast), _d = _c.next(); !_d.done; _d = _c.next()) {
                var statement = _d.value;
                if (!(statement instanceof brs.parser.Stmt.Function)) {
                    continue;
                }
                var functionType = new FunctionType_1.FunctionType(util_1.default.valueKindToBrsType(statement.func.returns));
                functionType.setName(statement.name.text);
                functionType.isSub = statement.func.keyword.text.toLowerCase() === 'sub';
                if (functionType.isSub) {
                    functionType.returnType = new VoidType_1.VoidType();
                }
                //extract the parameters
                var params = [];
                try {
                    for (var _e = __values(statement.func.parameters), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var param = _f.value;
                        var callableParam = {
                            name: param.name.text,
                            type: util_1.default.valueKindToBrsType(param.type.kind),
                            isOptional: !!param.defaultValue,
                            isRestArgument: false
                        };
                        params.push(callableParam);
                        var isRequired = !param.defaultValue;
                        functionType.addParameter(callableParam.name, callableParam.type, isRequired);
                    }
                }
                catch (e_12_1) { e_12 = { error: e_12_1 }; }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                    }
                    finally { if (e_12) throw e_12.error; }
                }
                this.callables.push({
                    isSub: statement.func.keyword.text.toLowerCase() === 'sub',
                    name: statement.name.text,
                    nameRange: util_1.default.locationToRange(statement.name.location),
                    file: this,
                    params: params,
                    //the function body starts on the next line (since we can't have one-line functions)
                    bodyRange: util_1.default.getBodyRangeForFunc(statement.func),
                    type: functionType
                });
            }
        }
        catch (e_11_1) { e_11 = { error: e_11_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_11) throw e_11.error; }
        }
    };
    BrsFile.prototype.findFunctionCalls = function (lines) {
        var e_13, _a, e_14, _b, e_15, _c;
        this.functionCalls = [];
        try {
            //for now, just dig into top-level function declarations.
            for (var _d = __values(this.ast), _e = _d.next(); !_e.done; _e = _d.next()) {
                var statement = _e.value;
                if (!statement.func) {
                    continue;
                }
                var bodyStatements = statement.func.body.statements;
                try {
                    for (var bodyStatements_1 = __values(bodyStatements), bodyStatements_1_1 = bodyStatements_1.next(); !bodyStatements_1_1.done; bodyStatements_1_1 = bodyStatements_1.next()) {
                        var bodyStatement = bodyStatements_1_1.value;
                        if (bodyStatement.expression && bodyStatement.expression instanceof brs.parser.Expr.Call) {
                            var expression = bodyStatement.expression;
                            //filter out dotted function invocations (i.e. object.doSomething()) (not currently supported. TODO support it)
                            if (bodyStatement.expression.callee.obj) {
                                continue;
                            }
                            var functionName = expression.callee.name.text;
                            //callee is the name of the function being called
                            var callee = expression.callee;
                            var calleeRange = util_1.default.locationToRange(callee.location);
                            var columnIndexBegin = calleeRange.start.character;
                            var columnIndexEnd = calleeRange.end.character;
                            var args = [];
                            try {
                                //TODO convert if stmts to use instanceof instead
                                for (var _f = __values(expression.args), _g = _f.next(); !_g.done; _g = _f.next()) {
                                    var arg = _g.value;
                                    //is variable being passed into argument
                                    if (arg.name) {
                                        args.push({
                                            range: util_1.default.locationToRange(arg.location),
                                            //TODO - look up the data type of the actual variable
                                            type: new DynamicType_1.DynamicType(),
                                            text: arg.name.text
                                        });
                                    }
                                    else if (arg.value) {
                                        var text = '';
                                        /* istanbul ignore next: TODO figure out why value is undefined sometimes */
                                        if (arg.value.value) {
                                            text = arg.value.value.toString();
                                        }
                                        var callableArg = {
                                            range: util_1.default.locationToRange(arg.location),
                                            type: util_1.default.valueKindToBrsType(arg.value.kind),
                                            text: text
                                        };
                                        //wrap the value in quotes because that's how it appears in the code
                                        if (callableArg.type instanceof StringType_1.StringType) {
                                            callableArg.text = '"' + callableArg.text + '"';
                                        }
                                        args.push(callableArg);
                                    }
                                    else {
                                        args.push({
                                            range: util_1.default.locationToRange(arg.location),
                                            type: new DynamicType_1.DynamicType(),
                                            //TODO get text from other types of args
                                            text: ''
                                        });
                                    }
                                }
                            }
                            catch (e_15_1) { e_15 = { error: e_15_1 }; }
                            finally {
                                try {
                                    if (_g && !_g.done && (_c = _f.return)) _c.call(_f);
                                }
                                finally { if (e_15) throw e_15.error; }
                            }
                            var functionCall = {
                                range: util_1.default.brsRangeFromPositions(expression.location.start, expression.closingParen.location.end),
                                functionScope: this.getFunctionScopeAtPosition(vscode_languageserver_1.Position.create(calleeRange.start.line, calleeRange.start.character)),
                                file: this,
                                name: functionName,
                                nameRange: vscode_languageserver_1.Range.create(calleeRange.start.line, columnIndexBegin, calleeRange.start.line, columnIndexEnd),
                                //TODO keep track of parameters
                                args: args
                            };
                            this.functionCalls.push(functionCall);
                        }
                    }
                }
                catch (e_14_1) { e_14 = { error: e_14_1 }; }
                finally {
                    try {
                        if (bodyStatements_1_1 && !bodyStatements_1_1.done && (_b = bodyStatements_1.return)) _b.call(bodyStatements_1);
                    }
                    finally { if (e_14) throw e_14.error; }
                }
            }
        }
        catch (e_13_1) { e_13 = { error: e_13_1 }; }
        finally {
            try {
                if (_e && !_e.done && (_a = _d.return)) _a.call(_d);
            }
            finally { if (e_13) throw e_13.error; }
        }
    };
    /**
     * Find the function scope at the given position.
     * @param position
     * @param functionScopes
     */
    BrsFile.prototype.getFunctionScopeAtPosition = function (position, functionScopes) {
        var e_16, _a;
        if (!functionScopes) {
            functionScopes = this.functionScopes;
        }
        try {
            for (var functionScopes_1 = __values(functionScopes), functionScopes_1_1 = functionScopes_1.next(); !functionScopes_1_1.done; functionScopes_1_1 = functionScopes_1.next()) {
                var scope = functionScopes_1_1.value;
                if (util_1.default.rangeContains(scope.range, position)) {
                    //see if any of that scope's children match the position also, and give them priority
                    var childScope = this.getFunctionScopeAtPosition(position, scope.childrenScopes);
                    if (childScope) {
                        return childScope;
                    }
                    else {
                        return scope;
                    }
                }
            }
        }
        catch (e_16_1) { e_16 = { error: e_16_1 }; }
        finally {
            try {
                if (functionScopes_1_1 && !functionScopes_1_1.done && (_a = functionScopes_1.return)) _a.call(functionScopes_1);
            }
            finally { if (e_16) throw e_16.error; }
        }
    };
    BrsFile.prototype.getCompletions = function (position, context) {
        var e_17, _a;
        var result = {
            completions: [],
            includeContextCallables: true,
        };
        //determine if cursor is inside a function
        var functionScope = this.getFunctionScopeAtPosition(position);
        if (!functionScope) {
            result.includeContextCallables = false;
            //we aren't in any function scope, so just return an empty list
            return result;
        }
        //TODO: if cursor is within a comment, disable completions
        var variables = functionScope.variableDeclarations;
        try {
            for (var variables_1 = __values(variables), variables_1_1 = variables_1.next(); !variables_1_1.done; variables_1_1 = variables_1.next()) {
                var variable = variables_1_1.value;
                result.completions.push({
                    label: variable.name,
                    kind: variable.type instanceof FunctionType_1.FunctionType ? vscode_languageserver_1.CompletionItemKind.Function : vscode_languageserver_1.CompletionItemKind.Variable
                });
            }
        }
        catch (e_17_1) { e_17 = { error: e_17_1 }; }
        finally {
            try {
                if (variables_1_1 && !variables_1_1.done && (_a = variables_1.return)) _a.call(variables_1);
            }
            finally { if (e_17) throw e_17.error; }
        }
        return result;
    };
    BrsFile.prototype.getHover = function (position) {
        var e_18, _a, e_19, _b;
        //get the token at the position
        var token = this.getTokenAt(position);
        var hoverTokenTypes = [
            Lexeme.Identifier,
            Lexeme.Function,
            Lexeme.EndFunction,
            Lexeme.Sub,
            Lexeme.EndSub
        ];
        //throw out invalid tokens and the wrong kind of tokens
        if (!token || hoverTokenTypes.indexOf(token.kind) === -1) {
            return null;
        }
        var lowerTokenText = token.text.toLowerCase();
        //look through local variables first
        {
            //get the function scope for this position (if exists)
            var functionScope = this.getFunctionScopeAtPosition(position);
            if (functionScope) {
                try {
                    //find any variable with this name
                    for (var _c = __values(functionScope.variableDeclarations), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var varDeclaration = _d.value;
                        //we found a variable declaration with this token text!
                        if (varDeclaration.name.toLowerCase() === lowerTokenText) {
                            var typeText = void 0;
                            if (varDeclaration.type instanceof FunctionType_1.FunctionType) {
                                typeText = varDeclaration.type.toString();
                            }
                            else {
                                typeText = varDeclaration.name + " as " + varDeclaration.type.toString();
                            }
                            return {
                                range: util_1.default.locationToRange(token.location),
                                //append the variable name to the front for context
                                contents: typeText
                            };
                        }
                    }
                }
                catch (e_18_1) { e_18 = { error: e_18_1 }; }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                    }
                    finally { if (e_18) throw e_18.error; }
                }
            }
        }
        //look through all callables in relevant contexts
        {
            var contexts = this.program.getContextsForFile(this);
            try {
                for (var contexts_1 = __values(contexts), contexts_1_1 = contexts_1.next(); !contexts_1_1.done; contexts_1_1 = contexts_1.next()) {
                    var context_1 = contexts_1_1.value;
                    var callable = context_1.getCallableByName(lowerTokenText);
                    if (callable) {
                        return {
                            range: util_1.default.locationToRange(token.location),
                            contents: callable.type.toString()
                        };
                    }
                }
            }
            catch (e_19_1) { e_19 = { error: e_19_1 }; }
            finally {
                try {
                    if (contexts_1_1 && !contexts_1_1.done && (_b = contexts_1.return)) _b.call(contexts_1);
                }
                finally { if (e_19) throw e_19.error; }
            }
        }
    };
    BrsFile.prototype.dispose = function () {
    };
    return BrsFile;
}());
exports.BrsFile = BrsFile;
//# sourceMappingURL=BrsFile.js.map