"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var events_1 = require("events");
var path = require("path");
var vscode_languageserver_1 = require("vscode-languageserver");
var DiagnosticMessages_1 = require("../DiagnosticMessages");
var util_1 = require("../util");
var XmlFile = /** @class */ (function () {
    function XmlFile(pathAbsolute, 
    /**
     * The absolute path to the file, relative to the pkg
     */
    pkgPath, program) {
        this.pathAbsolute = pathAbsolute;
        this.pkgPath = pkgPath;
        this.program = program;
        this.ownScriptImports = [];
        this.parseDiagnistics = [];
        //TODO implement the xml CDATA parsing, which would populate this list
        this.callables = [];
        //TODO implement the xml CDATA parsing, which would populate this list
        this.functionCalls = [];
        this.functionScopes = [];
        /**
         * Indicates if this file was processed by the program yet.
         */
        this.wasProcessed = false;
        this.emitter = new events_1.EventEmitter();
        this.extension = path.extname(pathAbsolute).toLowerCase();
        //allow unlimited listeners
        this.emitter.setMaxListeners(0);
    }
    XmlFile.prototype.getDiagnostics = function () {
        return __spread(this.parseDiagnistics);
    };
    XmlFile.prototype.parse = function (fileContents) {
        return __awaiter(this, void 0, void 0, function () {
            var e_1, _a, e_2, _b, lines, parsedXml, componentRange, lineIndex, match, e_3, match, lineIndex, columnIndex, scripts, scriptImports, scripts_1, scripts_1_1, script, uri, uriRanges, lineIndex, line, regex, lineIndexOffset, match, preUriContent, uri, startColumnIndex, endColumnIndex, scriptImports_1, scriptImports_1_1, scriptImport, range;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (this.wasProcessed) {
                            throw new Error("File was already processed. Create a new file instead. " + this.pathAbsolute);
                        }
                        lines = util_1.default.getLines(fileContents);
                        this.parentNameRange = this.findExtendsPosition(fileContents);
                        //create a range of the entire file
                        this.fileRange = vscode_languageserver_1.Range.create(0, 0, lines.length, lines[lines.length - 1].length - 1);
                        _c.label = 1;
                    case 1:
                        _c.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, util_1.default.parseXml(fileContents)];
                    case 2:
                        parsedXml = _c.sent();
                        if (parsedXml && parsedXml.component) {
                            if (parsedXml.component.$) {
                                this.componentName = parsedXml.component.$.name;
                                this.parentName = parsedXml.component.$.extends;
                            }
                            componentRange = void 0;
                            //find the range for the component element's opening tag
                            for (lineIndex = 0; lineIndex < lines.length; lineIndex++) {
                                match = /(.*)(<component)/gi.exec(lines[lineIndex]);
                                if (match) {
                                    componentRange = vscode_languageserver_1.Range.create(vscode_languageserver_1.Position.create(lineIndex, match[1].length), vscode_languageserver_1.Position.create(lineIndex, match[0].length));
                                    break;
                                }
                            }
                            //component name not defined
                            if (!this.componentName) {
                                this.parseDiagnistics.push(__assign({}, DiagnosticMessages_1.diagnosticMessages.Component_missing_name_attribute_1006(), { location: vscode_languageserver_1.Range.create(componentRange.start.line, componentRange.start.character, componentRange.start.line, componentRange.end.character), file: this, severity: 'error' }));
                            }
                            //parent component name not defined
                            if (!this.parentName) {
                                this.parseDiagnistics.push(__assign({}, DiagnosticMessages_1.diagnosticMessages.Component_missing_extends_attribute_1007(), { location: vscode_languageserver_1.Range.create(componentRange.start.line, componentRange.start.character, componentRange.start.line, componentRange.end.character), file: this, severity: 'error' }));
                            }
                        }
                        else {
                            //the component xml element was not found in the file
                            this.parseDiagnistics.push(__assign({}, DiagnosticMessages_1.diagnosticMessages.Xml_component_missing_component_declaration_1005(), { location: vscode_languageserver_1.Range.create(0, 0, 0, Number.MAX_VALUE), file: this, severity: 'error' }));
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        e_3 = _c.sent();
                        match = /(.*)\r?\nLine:\s*(\d+)\r?\nColumn:\s*(\d+)\r?\nChar:\s*(\d*)/gi.exec(e_3.message);
                        if (match) {
                            lineIndex = parseInt(match[2]);
                            columnIndex = parseInt(match[3]) - 1;
                            //add basic xml parse diagnostic errors
                            this.parseDiagnistics.push({
                                message: match[1],
                                code: DiagnosticMessages_1.diagnosticMessages.Xml_parse_error_1008().code,
                                location: vscode_languageserver_1.Range.create(lineIndex, columnIndex, lineIndex, columnIndex),
                                file: this,
                                severity: 'error'
                            });
                        }
                        return [3 /*break*/, 4];
                    case 4:
                        //find script imports
                        if (parsedXml && parsedXml.component) {
                            scripts = parsedXml.component.script ? parsedXml.component.script : [];
                            scriptImports = [];
                            try {
                                //get a list of all scripts
                                for (scripts_1 = __values(scripts), scripts_1_1 = scripts_1.next(); !scripts_1_1.done; scripts_1_1 = scripts_1.next()) {
                                    script = scripts_1_1.value;
                                    uri = script.$.uri;
                                    if (typeof uri === 'string') {
                                        scriptImports.push({
                                            sourceFile: this,
                                            text: uri,
                                            lineIndex: null,
                                            columnIndexBegin: null,
                                            columnIndexEnd: null,
                                            pkgPath: util_1.default.getPkgPathFromTarget(this.pkgPath, uri)
                                        });
                                    }
                                }
                            }
                            catch (e_1_1) { e_1 = { error: e_1_1 }; }
                            finally {
                                try {
                                    if (scripts_1_1 && !scripts_1_1.done && (_a = scripts_1.return)) _a.call(scripts_1);
                                }
                                finally { if (e_1) throw e_1.error; }
                            }
                            uriRanges = {};
                            for (lineIndex = 0; lineIndex < lines.length; lineIndex++) {
                                line = lines[lineIndex];
                                regex = /(.*?\s+uri\s*=\s*")(.*?)"/gi;
                                lineIndexOffset = 0;
                                match = void 0;
                                while (match = regex.exec(line)) {
                                    preUriContent = match[1];
                                    uri = match[2];
                                    if (!uriRanges[uri]) {
                                        uriRanges[uri] = [];
                                    }
                                    startColumnIndex = lineIndexOffset + preUriContent.length;
                                    endColumnIndex = startColumnIndex + uri.length;
                                    uriRanges[uri].push(vscode_languageserver_1.Range.create(lineIndex, startColumnIndex, lineIndex, endColumnIndex));
                                    lineIndexOffset += match[0].length;
                                }
                            }
                            try {
                                //try to compute the locations of each script import
                                for (scriptImports_1 = __values(scriptImports), scriptImports_1_1 = scriptImports_1.next(); !scriptImports_1_1.done; scriptImports_1_1 = scriptImports_1.next()) {
                                    scriptImport = scriptImports_1_1.value;
                                    range = uriRanges[scriptImport.text].shift();
                                    scriptImport.lineIndex = range.start.line;
                                    scriptImport.columnIndexBegin = range.start.character;
                                    scriptImport.columnIndexEnd = range.end.character;
                                }
                            }
                            catch (e_2_1) { e_2 = { error: e_2_1 }; }
                            finally {
                                try {
                                    if (scriptImports_1_1 && !scriptImports_1_1.done && (_b = scriptImports_1.return)) _b.call(scriptImports_1);
                                }
                                finally { if (e_2) throw e_2.error; }
                            }
                            //add all of these script imports
                            this.ownScriptImports = scriptImports;
                        }
                        this.wasProcessed = true;
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get the list of scripts imported by this component and all of its ancestors
     */
    XmlFile.prototype.getAllScriptImports = function () {
        var imports = __spread(this.ownScriptImports);
        var file = this;
        while (file.parent) {
            imports = __spread(imports, file.parent.getOwnScriptImports());
            file = file.parent;
        }
        return imports;
    };
    /**
     * Get the list of scripts explicitly imported by this file.
     * This method excludes any ancestor imports
     */
    XmlFile.prototype.getOwnScriptImports = function () {
        return this.ownScriptImports;
    };
    /**
     * Determines if this xml file has a reference to the specified file (or if it's itself)
     * @param file
     */
    XmlFile.prototype.doesReferenceFile = function (file) {
        var e_4, _a;
        if (file === this) {
            return true;
        }
        try {
            for (var _b = __values(this.ownScriptImports), _c = _b.next(); !_c.done; _c = _b.next()) {
                var scriptImport = _c.value;
                //if the script imports the file
                if (scriptImport.pkgPath.toLowerCase() === file.pkgPath.toLowerCase()) {
                    return true;
                }
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_4) throw e_4.error; }
        }
        //if this is an xml file...do we extend the component it defines?
        if (path.extname(file.pkgPath).toLowerCase() === '.xml') {
            //didn't find any script imports for this file
            return false;
        }
    };
    /**
     * Get all available completions for the specified position
     * @param lineIndex
     * @param columnIndex
     */
    XmlFile.prototype.getCompletions = function (position) {
        var result = {
            completions: [],
            includeContextCallables: false,
        };
        var scriptImport = this.getScriptImportAtPosition(position);
        if (scriptImport) {
            result.completions = __spread(this.getScriptImportCompletions(scriptImport));
        }
        return result;
    };
    XmlFile.prototype.getScriptImportAtPosition = function (position) {
        var scriptImport = this.ownScriptImports.find(function (x) {
            return x.lineIndex === position.line &&
                //column between start and end
                position.character >= x.columnIndexBegin &&
                position.character <= x.columnIndexEnd;
        });
        return scriptImport;
    };
    XmlFile.prototype.getScriptImportCompletions = function (scriptImport) {
        var result = [];
        //get a list of all scripts currently being imported
        var currentImports = this.ownScriptImports.map(function (x) { return x.pkgPath; });
        //restrict to only .brs files
        for (var key in this.program.files) {
            var file = this.program.files[key];
            if (
            //is a brightscript file
            (file.extension === '.bs' || file.extension === '.brs') &&
                //not already referenced in this file
                currentImports.indexOf(file.pkgPath) === -1) {
                //the text range to replace if the user selects this result
                var range = {
                    start: {
                        character: scriptImport.columnIndexBegin,
                        line: scriptImport.lineIndex
                    },
                    end: {
                        character: scriptImport.columnIndexEnd,
                        line: scriptImport.lineIndex
                    }
                };
                //add the relative path
                var relativePath = util_1.default.getRelativePath(this.pkgPath, file.pkgPath).replace(/\\/g, '/');
                var pkgPath = 'pkg:/' + file.pkgPath.replace(/\\/g, '/');
                result.push({
                    label: relativePath,
                    detail: file.pathAbsolute,
                    kind: vscode_languageserver_1.CompletionItemKind.File,
                    textEdit: {
                        newText: relativePath,
                        range: range
                    }
                });
                //add the absolute path
                result.push({
                    label: pkgPath,
                    detail: file.pathAbsolute,
                    kind: vscode_languageserver_1.CompletionItemKind.File,
                    textEdit: {
                        newText: pkgPath,
                        range: range
                    }
                });
            }
        }
        return result;
    };
    /**
     * Scan the xml and find the range of the parent component's name in the `extends="ParentComponentName"` attribute of the component
     */
    XmlFile.prototype.findExtendsPosition = function (fullText) {
        var regexp = /.*<component[^>]*((extends\s*=\s*")(\w*)")/gms;
        var match = regexp.exec(fullText);
        if (match) {
            var extendsText = match[1]; // `extends="something"`
            var extendsToFirstQuote = match[2]; // `extends="`
            var componentName = match[3]; // `something`
            var lines = util_1.default.getLines(match[0]);
            for (var lineIndex = 0; lineIndex < lines.length; lineIndex++) {
                var line = lines[lineIndex];
                var extendsIdx = line.indexOf(extendsText);
                //we found the line index
                if (extendsIdx > -1) {
                    var colStartIndex = extendsIdx + extendsToFirstQuote.length;
                    var colEndIndex = colStartIndex + componentName.length;
                    return vscode_languageserver_1.Range.create(lineIndex, colStartIndex, lineIndex, colEndIndex);
                }
            }
        }
    };
    XmlFile.prototype.on = function (name, callback) {
        var _this = this;
        this.emitter.on(name, callback);
        return function () {
            _this.emitter.removeListener(name, callback);
        };
    };
    XmlFile.prototype.emit = function (name, data) {
        this.emitter.emit(name, data);
    };
    /**
     * Components can extend another component.
     * This method attaches the parent component to this component, where
     * this component can listen for script import changes on the parent.
     * @param parent
     */
    XmlFile.prototype.attachParent = function (parent) {
        //detach any existing parent
        this.detachParent();
        this.parent = parent;
        this.emit('attach-parent', parent);
    };
    XmlFile.prototype.detachParent = function () {
        if (this.parent) {
            this.parent = undefined;
            this.emit('detach-parent');
        }
    };
    XmlFile.prototype.getHover = function (position) {
        //TODO implement
        // let result = {} as Hover;
        return null;
    };
    XmlFile.prototype.getFunctionScopeAtPosition = function (position, functionScopes) {
        //TODO implement
        return null;
    };
    XmlFile.prototype.dispose = function () {
        this.emitter.removeAllListeners();
    };
    return XmlFile;
}());
exports.XmlFile = XmlFile;
//# sourceMappingURL=XmlFile.js.map