"use strict";
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var DynamicType_1 = require("./DynamicType");
var ArrayType = /** @class */ (function () {
    function ArrayType() {
        var innerTypes = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            innerTypes[_i] = arguments[_i];
        }
        this.innerTypes = [];
        this.innerTypes = innerTypes;
    }
    ArrayType.prototype.isAssignableTo = function (targetType) {
        var e_1, _a, e_2, _b;
        if (targetType instanceof DynamicType_1.DynamicType) {
            return true;
        }
        else if (!(targetType instanceof ArrayType)) {
            return false;
        }
        try {
            //this array type is assignable to the target IF
            //1. all of the types in this array are present in the target
            outer: for (var _c = __values(this.innerTypes), _d = _c.next(); !_d.done; _d = _c.next()) {
                var innerType = _d.value;
                try {
                    //find this inner type in the target
                    for (var _e = __values(targetType.innerTypes), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var targetInnerType = _f.value;
                        if (innerType.isAssignableTo(targetInnerType)) {
                            continue outer;
                        }
                        //our array contains a type that the target array does not...so these arrays are different
                        return false;
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    ArrayType.prototype.isConvertibleTo = function (targetType) {
        return this.isAssignableTo(targetType);
    };
    ArrayType.prototype.toString = function () {
        return "Array<" + this.innerTypes.map(function (x) { return x.toString(); }).join(' | ') + ">";
    };
    return ArrayType;
}());
exports.ArrayType = ArrayType;
//# sourceMappingURL=ArrayType.js.map