"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var DynamicType_1 = require("./DynamicType");
var FloatType_1 = require("./FloatType");
var IntegerType_1 = require("./IntegerType");
var LongIntegerType_1 = require("./LongIntegerType");
var DoubleType = /** @class */ (function () {
    function DoubleType() {
    }
    DoubleType.prototype.isAssignableTo = function (targetType) {
        return (targetType instanceof DoubleType ||
            targetType instanceof DynamicType_1.DynamicType);
    };
    DoubleType.prototype.isConvertibleTo = function (targetType) {
        if (targetType instanceof DynamicType_1.DynamicType ||
            targetType instanceof IntegerType_1.IntegerType ||
            targetType instanceof FloatType_1.FloatType ||
            targetType instanceof DoubleType ||
            targetType instanceof LongIntegerType_1.LongIntegerType) {
            return true;
        }
        else {
            return false;
        }
    };
    DoubleType.prototype.toString = function () {
        return 'double';
    };
    return DoubleType;
}());
exports.DoubleType = DoubleType;
//# sourceMappingURL=DoubleType.js.map