"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var DynamicType_1 = require("./DynamicType");
var FunctionType_1 = require("./FunctionType");
var IntegerType_1 = require("./IntegerType");
var StringType_1 = require("./StringType");
var VoidType_1 = require("./VoidType");
describe('FunctionType', function () {
    it('is equivalent to dynamic type', function () {
        chai_1.expect(new FunctionType_1.FunctionType(new VoidType_1.VoidType()).isAssignableTo(new DynamicType_1.DynamicType())).to.be.true;
    });
    it('validates using param and return types', function () {
        chai_1.expect(new FunctionType_1.FunctionType(new VoidType_1.VoidType()).isAssignableTo(new FunctionType_1.FunctionType(new VoidType_1.VoidType()))).to.be.true;
        //different parameter count
        chai_1.expect(new FunctionType_1.FunctionType(new VoidType_1.VoidType()).addParameter('a', new IntegerType_1.IntegerType(), true).isAssignableTo(new FunctionType_1.FunctionType(new VoidType_1.VoidType()))).to.be.false;
        //different parameter types
        chai_1.expect(new FunctionType_1.FunctionType(new VoidType_1.VoidType()).addParameter('a', new IntegerType_1.IntegerType(), true).isAssignableTo(new FunctionType_1.FunctionType(new VoidType_1.VoidType()).addParameter('a', new StringType_1.StringType(), true))).to.be.false;
        //different return type
        chai_1.expect(new FunctionType_1.FunctionType(new VoidType_1.VoidType()).isAssignableTo(new FunctionType_1.FunctionType(new IntegerType_1.IntegerType()))).to.be.false;
    });
});
//# sourceMappingURL=FunctionType.spec.js.map