"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = require("chalk");
var fsExtra = require("fs-extra");
var moment = require("moment");
var path = require("path");
var rokuDeploy = require("roku-deploy");
var vscode_languageserver_1 = require("vscode-languageserver");
var vscode_uri_1 = require("vscode-uri");
var xml2js = require("xml2js");
var BrsFile_1 = require("./files/BrsFile");
var interfaces_1 = require("./interfaces");
var BooleanType_1 = require("./types/BooleanType");
var DoubleType_1 = require("./types/DoubleType");
var DynamicType_1 = require("./types/DynamicType");
var FloatType_1 = require("./types/FloatType");
var FunctionType_1 = require("./types/FunctionType");
var IntegerType_1 = require("./types/IntegerType");
var InvalidType_1 = require("./types/InvalidType");
var LongIntegerType_1 = require("./types/LongIntegerType");
var ObjectType_1 = require("./types/ObjectType");
var StringType_1 = require("./types/StringType");
var UninitializedType_1 = require("./types/UninitializedType");
var VoidType_1 = require("./types/VoidType");
var Util = /** @class */ (function () {
    function Util() {
    }
    Util.prototype.log = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        //print an empty line
        console.log('');
        var timestamp = '[' + chalk_1.default.grey(moment().format('hh:mm:ss A')) + ']';
        console.log.apply(console.log, __spread([timestamp], args));
        //print an empty line
        console.log('');
    };
    Util.prototype.clearConsole = function () {
        process.stdout.write('\x1Bc');
    };
    /**
     * Determine if the file exists
     * @param filePath
     */
    Util.prototype.fileExists = function (filePath) {
        return new Promise(function (resolve, reject) {
            fsExtra.exists(filePath, resolve);
        });
    };
    /**
     * Load a file from disc into a string
     * @param filePath
     */
    Util.prototype.getFileContents = function (filePath) {
        return __awaiter(this, void 0, void 0, function () {
            var file, fileContents;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, fsExtra.readFile(filePath)];
                    case 1:
                        file = _a.sent();
                        fileContents = file.toString();
                        return [2 /*return*/, fileContents];
                }
            });
        });
    };
    /**
     * Make the path absolute, and replace all separators with the current OS's separators
     * @param filePath
     */
    Util.prototype.normalizeFilePath = function (filePath) {
        return path.normalize(path.resolve(filePath));
    };
    /**
     * Find the path to the config file.
     * If the config file path doesn't exist
     * @param configFilePath
     */
    Util.prototype.getConfigFilePath = function (cwd) {
        return __awaiter(this, void 0, void 0, function () {
            var configPath, i, parentDirPath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cwd = cwd ? cwd : process.cwd();
                        configPath = path.join(cwd, 'brsconfig.json');
                        i = 0;
                        _a.label = 1;
                    case 1:
                        if (!(i < 100)) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.fileExists(configPath)];
                    case 2:
                        if (_a.sent()) {
                            return [2 /*return*/, configPath];
                        }
                        else {
                            parentDirPath = path.dirname(path.dirname(configPath));
                            configPath = path.join(parentDirPath, 'brsconfig.json');
                        }
                        _a.label = 3;
                    case 3:
                        i++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Load the contents of a config file.
     * If the file extends another config, this will load the base config as well.
     * @param configFilePath
     * @param parentProjectPaths
     */
    Util.prototype.loadConfigFile = function (configFilePath, parentProjectPaths) {
        return __awaiter(this, void 0, void 0, function () {
            var cwd, projectFileContents, projectConfig, result, baseProjectConfig, ancestors;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cwd = process.cwd();
                        if (!configFilePath) return [3 /*break*/, 5];
                        //keep track of the inheritance chain
                        parentProjectPaths = parentProjectPaths ? parentProjectPaths : [];
                        configFilePath = path.resolve(configFilePath);
                        if (parentProjectPaths && parentProjectPaths.indexOf(configFilePath) > -1) {
                            parentProjectPaths.push(configFilePath);
                            parentProjectPaths.reverse();
                            throw new Error('Circular dependency detected: "' + parentProjectPaths.join('" => ') + '"');
                        }
                        return [4 /*yield*/, this.getFileContents(configFilePath)];
                    case 1:
                        projectFileContents = _a.sent();
                        projectConfig = JSON.parse(projectFileContents);
                        //set working directory to the location of the project file
                        process.chdir(path.dirname(configFilePath));
                        result = void 0;
                        if (!(projectConfig && typeof projectConfig.extends === 'string')) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.loadConfigFile(projectConfig.extends, __spread(parentProjectPaths, [configFilePath]))];
                    case 2:
                        baseProjectConfig = _a.sent();
                        //extend the base config with the current project settings
                        result = Object.assign({}, baseProjectConfig, projectConfig);
                        return [3 /*break*/, 4];
                    case 3:
                        result = projectConfig;
                        ancestors = parentProjectPaths ? parentProjectPaths : [];
                        ancestors.push(configFilePath);
                        result._ancestors = parentProjectPaths;
                        _a.label = 4;
                    case 4:
                        //make any paths in the config absolute (relative to the CURRENT config file)
                        if (result.outFile) {
                            result.outFile = path.resolve(result.outFile);
                        }
                        if (result.rootDir) {
                            result.rootDir = path.resolve(result.rootDir);
                        }
                        if (result.cwd) {
                            result.cwd = path.resolve(result.cwd);
                        }
                        //restore working directory
                        process.chdir(cwd);
                        return [2 /*return*/, result];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Given a BrsConfig object, start with defaults,
     * merge with brsconfig.json and the provided options.
     * @param config
     */
    Util.prototype.normalizeAndResolveConfig = function (config) {
        return __awaiter(this, void 0, void 0, function () {
            var result, _a, configFile;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        result = this.normalizeConfig({});
                        if (!(!config || !config.project)) return [3 /*break*/, 2];
                        _a = result;
                        return [4 /*yield*/, this.getConfigFilePath()];
                    case 1:
                        _a.project = _b.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        //use the config's project link
                        result.project = config.project;
                        _b.label = 3;
                    case 3:
                        if (!result.project) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.loadConfigFile(result.project)];
                    case 4:
                        configFile = _b.sent();
                        result = Object.assign(result, configFile);
                        _b.label = 5;
                    case 5:
                        //override the defaults with the specified options
                        result = Object.assign(result, config);
                        return [2 /*return*/, result];
                }
            });
        });
    };
    /**
     * Set defaults for any missing items
     * @param config
     */
    Util.prototype.normalizeConfig = function (config) {
        config = config ? config : {};
        config.deploy = config.deploy === true ? true : false;
        //use default options from rokuDeploy
        config.files = config.files ? config.files : rokuDeploy.getOptions().files;
        config.skipPackage = config.skipPackage === true ? true : false;
        var rootFolderName = path.basename(process.cwd());
        config.outFile = config.outFile ? config.outFile : "./out/" + rootFolderName + ".zip";
        config.username = config.username ? config.username : 'rokudev';
        config.watch = config.watch === true ? true : false;
        config.ignoreErrorCodes = config.ignoreErrorCodes ? config.ignoreErrorCodes : [];
        config.emitFullPaths = config.emitFullPaths === true ? true : false;
        return config;
    };
    /**
     * Get the root directory from options.
     * Falls back to options.cwd.
     * Falls back to process.cwd
     * @param options
     */
    Util.prototype.getRootDir = function (options) {
        var cwd = options.cwd;
        cwd = cwd ? cwd : process.cwd();
        var rootDir = options.rootDir ? options.rootDir : cwd;
        rootDir = path.resolve(cwd, rootDir);
        return rootDir;
    };
    /**
     * Format a string with placeholders replaced by argument indexes
     * @param subject
     * @param params
     */
    Util.prototype.stringFormat = function (subject) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        return subject.replace(/{(\d+)}/g, function (match, num) {
            return typeof args[num] !== 'undefined' ? args[num] : match;
        });
    };
    Util.prototype.valueKindToBrsType = function (kind) {
        switch (kind) {
            case interfaces_1.ValueKind.Boolean: return new BooleanType_1.BooleanType();
            //TODO refine the function type on the outside (I don't think this ValueKind is actually returned)
            case interfaces_1.ValueKind.Callable: return new FunctionType_1.FunctionType(new VoidType_1.VoidType());
            case interfaces_1.ValueKind.Double: return new DoubleType_1.DoubleType();
            case interfaces_1.ValueKind.Dynamic: return new DynamicType_1.DynamicType();
            case interfaces_1.ValueKind.Float: return new FloatType_1.FloatType();
            case interfaces_1.ValueKind.Int32: return new IntegerType_1.IntegerType();
            case interfaces_1.ValueKind.Int64: return new LongIntegerType_1.LongIntegerType();
            case interfaces_1.ValueKind.Invalid: return new InvalidType_1.InvalidType();
            case interfaces_1.ValueKind.Object: return new ObjectType_1.ObjectType();
            case interfaces_1.ValueKind.String: return new StringType_1.StringType();
            case interfaces_1.ValueKind.Uninitialized: return new UninitializedType_1.UninitializedType();
            case interfaces_1.ValueKind.Void: return new VoidType_1.VoidType();
        }
    };
    /**
     * Convert a 1-indexed brs Location to a 0-indexed vscode range
     * @param location
     */
    Util.prototype.locationToRange = function (location) {
        return vscode_languageserver_1.Range.create(
        //brs error lines are 1-indexed
        location.start.line - 1, 
        //brs error columns are 0-based
        location.start.column, location.end.line - 1, location.end.column);
    };
    /**
     * Compute the range of a function's body
     * @param func
     */
    Util.prototype.getBodyRangeForFunc = function (func) {
        return vscode_languageserver_1.Range.create(
        //func body begins at start of line after its declaration
        func.location.start.line, 0, 
        //func body ends right before the `end function|sub` line
        func.end.location.start.line - 1, 
        //brs location columns are 0-based
        func.end.location.start.column);
    };
    /**
     * Given a list of callables, get that as a a dictionary indexed by name.
     * @param callables
     */
    Util.prototype.getCallableContainersByLowerName = function (callables) {
        var e_1, _a;
        //find duplicate functions
        var result = {};
        try {
            for (var callables_1 = __values(callables), callables_1_1 = callables_1.next(); !callables_1_1.done; callables_1_1 = callables_1.next()) {
                var callableContainer = callables_1_1.value;
                var lowerName = callableContainer.callable.name.toLowerCase();
                //create a new array for this name
                if (result[lowerName] === undefined) {
                    result[lowerName] = [];
                }
                result[lowerName].push(callableContainer);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (callables_1_1 && !callables_1_1.done && (_a = callables_1.return)) _a.call(callables_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return result;
    };
    /**
     *
     * @param severity
     */
    Util.prototype.severityToDiagnostic = function (severity) {
        switch (severity) {
            case 'hint':
                return vscode_languageserver_1.DiagnosticSeverity.Hint;
            case 'information':
                return vscode_languageserver_1.DiagnosticSeverity.Information;
            case 'warning':
                return vscode_languageserver_1.DiagnosticSeverity.Warning;
            case 'error':
            default:
                return vscode_languageserver_1.DiagnosticSeverity.Error;
        }
    };
    /**
     * Split a file by newline characters (LF or CRLF)
     * @param text
     */
    Util.prototype.getLines = function (text) {
        return text.split(/\r?\n/);
    };
    /**
     * Given an absollute path to a source file, and a target path,
     * compute the pkg path for the target relative to the source file's location
     * @param containingFilePathAbsolute
     * @param targetPath
     */
    Util.prototype.getPkgPathFromTarget = function (containingFilePathAbsolute, targetPath) {
        var e_2, _a;
        //if the target starts with 'pkg:', it's an absolute path. Return as is
        if (targetPath.indexOf('pkg:/') === 0) {
            targetPath = targetPath.substring(5);
            if (targetPath === '') {
                return null;
            }
            else {
                return path.normalize(targetPath);
            }
        }
        if (targetPath === 'pkg:') {
            return null;
        }
        //remove the filename
        var containingFolder = path.normalize(path.dirname(containingFilePathAbsolute));
        //start with the containing folder, split by slash
        var result = containingFolder.split(path.sep);
        //split on slash
        var targetParts = path.normalize(targetPath).split(path.sep);
        try {
            for (var targetParts_1 = __values(targetParts), targetParts_1_1 = targetParts_1.next(); !targetParts_1_1.done; targetParts_1_1 = targetParts_1.next()) {
                var part = targetParts_1_1.value;
                if (part === '' || part === '.') {
                    //do nothing, it means current directory
                    continue;
                }
                if (part === '..') {
                    //go up one directory
                    result.pop();
                }
                else {
                    result.push(part);
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (targetParts_1_1 && !targetParts_1_1.done && (_a = targetParts_1.return)) _a.call(targetParts_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return result.join(path.sep);
    };
    /**
     * Compute the relative path from the source file to the target file
     * @param pkgSourcePathAbsolute  - the absolute path to the source relative to the package location
     * @param pkgTargetPathAbsolute  - the absolute path ro the target relative to the package location
     */
    Util.prototype.getRelativePath = function (pkgSourcePathAbsolute, pkgTargetPathAbsolute) {
        pkgSourcePathAbsolute = path.normalize(pkgSourcePathAbsolute);
        pkgTargetPathAbsolute = path.normalize(pkgTargetPathAbsolute);
        //break by path separator
        var sourceParts = pkgSourcePathAbsolute.split(path.sep);
        var targetParts = pkgTargetPathAbsolute.split(path.sep);
        var commonParts = [];
        //find their common root
        for (var i = 0; i < targetParts.length; i++) {
            if (targetParts[i].toLowerCase() === sourceParts[i].toLowerCase()) {
                commonParts.push(targetParts[i]);
            }
            else {
                //we found a non-matching part...so no more commonalities past this point
                break;
            }
        }
        //throw out the common parts from both sets
        sourceParts.splice(0, commonParts.length);
        targetParts.splice(0, commonParts.length);
        //throw out the filename part of source
        sourceParts.splice(sourceParts.length - 1, 1);
        //start out by adding updir paths for each remaining source part
        var resultParts = sourceParts.map(function (x) { return '..'; });
        //now add every target part
        resultParts = __spread(resultParts, targetParts);
        return path.join.apply(path, resultParts);
    };
    /**
     * Find all properties in an object that match the predicate.
     * @param obj
     * @param predicate
     * @param parentKey
     */
    Util.prototype.findAllDeep = function (obj, predicate, parentKey) {
        var result = [];
        //base case. If this object maches, keep it as a result
        if (predicate(obj) === true) {
            result.push({
                key: parentKey,
                value: obj
            });
        }
        //look through all children
        if (obj instanceof Object) {
            for (var key in obj) {
                var value = obj[key];
                var fullKey = parentKey ? parentKey + '.' + key : key;
                if (typeof value === 'object') {
                    result = __spread(result, this.findAllDeep(value, predicate, fullKey));
                }
            }
        }
        return result;
    };
    /**
     * Test if `position` is in `range`. If the position is at the edges, will return true.
     * Adapted from core vscode
     * @param range
     * @param position
     */
    Util.prototype.rangeContains = function (range, position) {
        if (position.line < range.start.line || position.line > range.end.line) {
            return false;
        }
        if (position.line === range.start.line && position.character < range.start.character) {
            return false;
        }
        if (position.line === range.end.line && position.character > range.end.character) {
            return false;
        }
        return true;
    };
    /**
     * Parse an xml file and get back a javascript object containing its results
     * @param text
     */
    Util.prototype.parseXml = function (text) {
        return new Promise(function (resolve, reject) {
            xml2js.parseString(text, function (err, data) {
                if (err) {
                    reject(err);
                }
                else {
                    resolve(data);
                }
            });
        });
    };
    Util.prototype.propertyCount = function (object) {
        var count = 0;
        for (var key in object) {
            if (object.hasOwnProperty(key)) {
                count++;
            }
        }
        return count;
    };
    Util.prototype.defer = function () {
        var resolve;
        var reject;
        var promise = new Promise(function (resolveValue, rejectValue) {
            resolve = resolveValue;
            reject = rejectValue;
        });
        return {
            promise: promise,
            resolve: resolve,
            reject: reject
        };
    };
    Util.prototype.padLeft = function (subject, totalLength, char) {
        totalLength = totalLength > 1000 ? 1000 : totalLength;
        while (subject.length < totalLength) {
            subject = char + subject;
        }
        return subject;
    };
    /**
     * Given a URI, convert that to a regular fs path
     * @param uri
     */
    Util.prototype.uriToPath = function (uri) {
        var parsedPath = vscode_uri_1.default.parse(uri).fsPath;
        //Uri annoyingly coverts all drive letters to lower case...so this will bring back whatever case it came in as
        var match = /\/\/\/([a-z]:)/i.exec(uri);
        if (match) {
            var originalDriveCasing = match[1];
            parsedPath = originalDriveCasing + parsedPath.substring(2);
        }
        var normalizedPath = path.normalize(parsedPath);
        return normalizedPath;
    };
    /**
     * Given a file path, convert it to a URI string
     */
    Util.prototype.pathToUri = function (pathAbsolute) {
        return vscode_uri_1.default.file(pathAbsolute).toString();
    };
    /**
     * Get the outDir from options, taking into account cwd and absolute outFile paths
     * @param options
     */
    Util.prototype.getOutDir = function (options) {
        options = this.normalizeConfig(options);
        var cwd = path.normalize(options.cwd ? options.cwd : process.cwd());
        if (path.isAbsolute(options.outFile)) {
            return path.dirname(options.outFile);
        }
        else {
            return path.normalize(path.join(cwd, path.dirname(options.outFile)));
        }
    };
    /**
     * Get paths to all files on disc that match this project's source list
     */
    Util.prototype.getFilePaths = function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var rootDir, files;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        rootDir = this.getRootDir(options);
                        return [4 /*yield*/, rokuDeploy.getFilePaths(options.files, path.dirname(options.outFile), rootDir)];
                    case 1:
                        files = _a.sent();
                        return [2 /*return*/, files];
                }
            });
        });
    };
    /**
     * Determine whether this diagnostic should be supressed or not, based on brs comment-flags
     * @param diagnostic
     */
    Util.prototype.diagnosticIsSuppressed = function (diagnostic) {
        var e_3, _a;
        //for now, we only support suppressing brs file diagnostics
        if (diagnostic.file instanceof BrsFile_1.BrsFile) {
            try {
                for (var _b = __values(diagnostic.file.commentFlags), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var flag = _c.value;
                    //this diagnostic is affected by this flag
                    if (this.rangeContains(flag.affectedRange, diagnostic.location.start)) {
                        //if the flag acts upon this diagnostic's code
                        if (flag.codes === null || flag.codes.indexOf(diagnostic.code) > -1) {
                            return true;
                        }
                    }
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_3) throw e_3.error; }
            }
        }
    };
    /**
     * Given a string, extract each item split by whitespace
     * @param text
     */
    Util.prototype.tokenizeByWhitespace = function (text) {
        var tokens = [];
        var currentToken = null;
        for (var i = 0; i < text.length; i++) {
            var char = text[i];
            //if we hit whitespace
            if (char === ' ' || char === '\t') {
                if (currentToken) {
                    tokens.push(currentToken);
                    currentToken = null;
                }
                //we hit non-whitespace
            }
            else {
                if (!currentToken) {
                    currentToken = {
                        startIndex: i,
                        text: ''
                    };
                }
                currentToken.text += char;
            }
        }
        if (currentToken) {
            tokens.push(currentToken);
        }
        return tokens;
    };
    /**
     * The BRS library uses 1-based line indexes, and 0 based column indexes.
     * However, vscode expects zero-based for everything.
     * @param start - the location.start object from brs
     * @param end - the location.end object from brs
     */
    Util.prototype.brsRangeFromPositions = function (start, end) {
        return vscode_languageserver_1.Range.create(start.line - 1, start.column, end.line - 1, end.column);
    };
    return Util;
}());
exports.Util = Util;
exports.util = new Util();
exports.default = exports.util;
//# sourceMappingURL=util.js.map